/*
 * Created on 28.04.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package applications.classification;

import java.util.ArrayList;
import java.util.List;

import weka.classifiers.CaseBasedAlgorithm;
import weka.classifiers.OnLineClassifier;
import weka.classifiers.RuleBasedAlgorithm;
import weka.classifiers.lazy.IBLDS;
import weka.classifiers.lazy.LWF;
import weka.classifiers.lazy.SlidingWindowIBk;
import weka.classifiers.lazy.TWFTree;
import weka.classifiers.rules.RBLDS;
import weka.core.Instance;
import weka.core.Instances;
import weka.datagenerators.AdaptiveGenerator;
import weka.datagenerators.GenGAUSS;
import weka.datagenerators.GenMIXED;
import weka.datagenerators.GenSINE2;
import weka.datagenerators.GenSTAGGER;
import weka.datagenerators.GeneratorHyperplane;
import weka.datagenerators.GeneratorMeans;
import weka.datagenerators.GeneratorRandom;
import weka.datagenerators.GeneratorRectDist;

/**
 * @author George
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SimpleOnlineTest {

    public static String dir = "D:/work/Research/AdaptiveClassifier/";

    protected static int steps;

    protected static int pos = 0;

    protected static int dimension;

    protected static double[][] minmax;

    protected static AdaptiveGenerator generator;

   
    public static void test4(AdaptiveGenerator gen,
            OnLineClassifier classifier,  int initSize,
            int streamSize) {
        try {
            CaseBasedAlgorithm cbClassifier = null;
            if (classifier instanceof CaseBasedAlgorithm)
                cbClassifier = (CaseBasedAlgorithm) classifier;

            RuleBasedAlgorithm rbClassifier = null;
            if (classifier instanceof RuleBasedAlgorithm)
                rbClassifier = (RuleBasedAlgorithm) classifier;

            Instances initInstances = gen.getInitData(initSize);

            classifier.buildClassifier(initInstances);
            int[] dist = new int[gen.getDatasetFormat().classAttribute()
                    .numValues()];
            int classCount = gen.getDatasetFormat().classAttribute()
                    .numValues();

            dimension = initInstances.numAttributes() - 2;

            pos = 0;

            int len = 1000;

            int sumClassify = 0;

            double diff = 1.0 / len;

            int step = 10;
            int cU = 0;
            double sumUTime = 0;
            for (int i = 0; i < streamSize; i++) {
                Instance inst = gen.generateExample(i);
                inst.setDataset(initInstances);
                int ncls = (int) inst.classValue();
                dist[ncls]++;
                int cl2 = (int) classifier.classifyInstance(inst);
                boolean next = (ncls == cl2);
                if (next)
                    sumClassify++;
                long startU = System.nanoTime();
                classifier.updateClassifier(inst);
                long endU = System.nanoTime();
                sumUTime += (endU - startU) / 1000000.0;
                cU++;
                if (i % step == 0) {
                    pos = 0;
                    int dif = 0;
                    int correct2 = 0;
                    double[] distrib = new double[classCount];
                    Instances ins = gen.getInitData(len);
                    double sumTime = 0;
                    for (int j = 0; j < len; j++) {
                        int lab = gen.getLabel(ins.instance(j));

                        Instance inst2 = ins.instance(j);
                        long startC = System.nanoTime();
                        int cls = (int) classifier.classifyInstance(inst2);
                        long endC = System.nanoTime();
                        sumTime += (endC - startC) / 1000000.0;
                        // if (cls == (int) in.classValue()) correct++;
                        if (cls == lab)
                            correct2++;
                        distrib[lab] += diff;
                    }
                    
                    double v = (double) correct2 / len;
                    System.out.print("Time:"+i+"  ");
                    System.out.print("AbsRate:" + (v) + "  ");
                    int v1 = sumClassify;
                    sumClassify = 0;
                    System.out.print("TrainRate:" + (v1) + "  ");

                    if (rbClassifier != null) {
                        System.out.print("Rules:" + rbClassifier.getRuleCount()
                                        + "  ");
                    }

                    if (cbClassifier != null) {
                        int size = cbClassifier.getTrainInstancesCount();
                        System.out.print("Insts:" + size + "  ");
                        if (size >= 6000)
                            break;
                    }
                    
                    sumTime /= len;
                    System.out.print("clsTime:" + sumTime + "  ");
                    sumUTime /= cU;
                    System.out.print("updTime:" + sumUTime + "\n");
                    sumUTime = 0;
                    cU = 0;

                    

                }
            }
            
        } catch (Exception e2) {
            e2.printStackTrace();
        }
    }

   
    

    
    

    public static void performTest(AdaptiveGenerator gen,
            OnLineClassifier classifier) {
        gen.reset();
        int atts = gen.defineDataFormat().numAttributes();
        List li = new ArrayList();
        for (int k = 1; k < atts - 1; k++) {
            li.add(new Integer(k));
        }
        classifier.setOperativeAttributes(li);
        test4(gen, classifier, 100, 50000);
        
    }

    

    
   
    public static AdaptiveGenerator[] gens = new AdaptiveGenerator[] {
        new GenGAUSS(), new GenSINE2(), new GeneratorRectDist(),
        new GenMIXED(), new GeneratorRandom(),
        new GeneratorMeans(5, 2, 0.1), new GeneratorHyperplane(2, 2, 0.5),
        new GeneratorMeans(5, 5, 0.1), new GeneratorHyperplane(5, 2, 0.5) };



  public static OnLineClassifier[] classifiers = new OnLineClassifier[] {
// new AdaptiveIBkTree2(5000, 50, 45, 5, 0.25, 4, 100, 10),
        new IBLDS(5000, 50, 45, 5, 0.25, 4, 100, 20),
        new RBLDS(1500, -1, false), new LWF(0.02), new LWF(0.04),
        new SlidingWindowIBk(200), new SlidingWindowIBk(400),
        new SlidingWindowIBk(800), new TWFTree(0.996), new TWFTree(0.998) };
    

    public static void main(String[] args) {
        //performTest(new GenSTAGGER(),new ART3(1500, -1, false));
        performTest(new GenSTAGGER(),new SlidingWindowIBk(200));
        
       
    }
}
