package applications.itext;

import java.awt.Color;
import java.io.FileOutputStream;
import java.io.IOException;

import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Element;
import com.lowagie.text.Font;
import com.lowagie.text.FontFactory;
import com.lowagie.text.Graphic;
import com.lowagie.text.PageSize;
import com.lowagie.text.Paragraph;
import com.lowagie.text.pdf.BaseFont;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfWriter;

public class TestIText {
    static public void main(String[] args){
    Document document = new Document();
    try {
        // step 2:
        // we create a writer that listens to the document
        // and directs a PDF-stream to a file
        PdfWriter writer = PdfWriter.getInstance(document,
                new FileOutputStream("D:/projects/itext/HelloWorld.pdf"));
        
        document.setPageSize(PageSize.A5);

        // step 3: we open the document
        document.open();
        // step 4: we add a paragraph to the document
        document.add(new Paragraph("Sudoku Nr.1",
                FontFactory.getFont(FontFactory.HELVETICA, 18, Font.BOLD, new Color(0, 0, 0))));
        
        Graphic g=new Graphic();
        float xpos=30;
        float ypos=500;
        float xdif=40;
        float ydif=40;
        int k=3;
        int n=k*k;
        
        for (int i=0;i<n;i++){
            for (int j=0;j<n;j++){
                g.drawBorder(1,Color.BLACK,xpos+xdif*i,ypos-ydif*j-ydif,xpos+xdif*i+xdif,ypos-ydif*j);
            }
        }
        for (int i=0;i<k;i++){
            for (int j=0;j<k;j++){
                g.drawBorder(3,Color.BLACK,xpos+xdif*k*i,ypos-ydif*k*j-ydif*k,xpos+xdif*k*i+xdif*k,ypos-ydif*k*j);
            }
        }
        g.drawBorder(4,Color.BLACK,xpos,ypos-ydif*n,xpos+xdif*n,ypos);
        document.add(g);
        
        
//      step 4: we grab the ContentByte and do some stuff with it
        PdfContentByte cb = writer.getDirectContent();
        
        // we tell the ContentByte we're ready to draw text
        cb.beginText();
        
        BaseFont bf = BaseFont.createFont(BaseFont.HELVETICA_BOLD, BaseFont.CP1252, BaseFont.NOT_EMBEDDED);
        cb.setFontAndSize(bf, 18);
        
        // we show some text starting on some absolute position with a given alignment
        cb.showTextAligned(PdfContentByte.ALIGN_CENTER, "8", xpos+xdif/2,ypos-ydif/2-7, 0);
        
        
        // we tell the contentByte, we've finished drawing text
        cb.endText();
        
        
//        Table table = new Table(3);
//        table.setBorderWidth(3);
//        table.setBorderColor(new Color(0, 0, 0));
//        table.setPadding(0);
//        table.setSpacing(0);
//        table.setTop(ypos);
//        table.setLeft(xpos);
//        table.setRight(xpos+xdif*n);
//       
//        
//        Table table2 = new Table(3);
//        table2.setBorderWidth(1);
//        table2.setBorderColor(new Color(0, 0, 0));
//        table2.setPadding(0);
//        table2.setSpacing(0);
//        
//        Cell cell = new Cell("1");
//        cell.setColspan(1);
//        cell.setRowspan(1);
//        cell.setHorizontalAlignment(Cell.ALIGN_CENTER);
//        cell.setVerticalAlignment(Cell.ALIGN_MIDDLE);
//        table2.addCell(cell,0,0);
//        cell = new Cell("2");
//        cell.setColspan(1);
//        table2.addCell(cell,1,0);
//        cell = new Cell(" ");
//        cell.setColspan(1);
//        table2.addCell(cell,2,0);
//        cell = new Cell("12");
//        cell.setColspan(1);
//        table2.addCell(cell,2,1);
//        cell = new Cell("8");
//        cell.setColspan(1);
//        cell.setHorizontalAlignment(Cell.ALIGN_CENTER);
//        cell.setVerticalAlignment(Cell.ALIGN_MIDDLE);
//        table2.addCell(cell,2,2);
//        
//        table.insertTable(table2,0,0);
//        
//        
//        document.add(table);
        
        
        
    } catch (DocumentException de) {
        System.err.println(de.getMessage());
    } catch (IOException ioe) {
        System.err.println(ioe.getMessage());
    }

    // step 5: we close the document
    document.close();
    }

}
