/*
 * Created on 11.08.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package applications.pipes;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

import utils.visibility.DrawField2D;
import weka.classifiers.CaseBasedAlgorithm;
import weka.classifiers.OnLineClassifier;
import weka.classifiers.RuleBasedAlgorithm;
import weka.classifiers.lazy.IBLDS;
import weka.classifiers.lazy.LWF;
import weka.classifiers.lazy.LWF2;
import weka.classifiers.lazy.SlidingWindowIBk;
import weka.classifiers.lazy.TWF;
import weka.classifiers.rules.RBLDS;
import weka.classifiers.rules.RBLDS7;
import weka.classifiers.rules.rise.SimpleConjunctiveRule;
import weka.core.Instance;
import weka.core.Instances;
import weka.datagenerators.AdaptiveGenerator;
import weka.datagenerators.GenSINE2;
import weka.datagenerators.GeneratorMeans;
import weka.datagenerators.GeneratorRandom;
import weka.datagenerators.GeneratorRectDist;
import weka.datagenerators.GeneratorRectSwitch;

/**
 * @author beringer
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class OnLineRuleVisTest implements Runnable {

    static public DrawField2D draw;

    static JTextField probfield;

    static DecimalFormat format;

    static Color[] cols = new Color[] { Color.BLACK, Color.RED, Color.BLUE,
            Color.GREEN, Color.YELLOW, Color.MAGENTA };

    static Color area = new Color(196, 255, 255);

    static public List drawData = new ArrayList();

    static public List markedData = new ArrayList();

    static List ruleData = new ArrayList();

    public static List markedRules = new ArrayList();

    static AdaptiveGenerator gen;

    static OnLineClassifier classifier;

    static double[] minmax = new double[] { 0, 1, 0, 1 };

    static boolean pause = true;

    static boolean stepping = false;

    static boolean breakRun = false;

    static boolean stopAll = false;

    public static void runAll() {

        Instances initInstances = gen.getInitData(100);
        Enumeration enum1 = initInstances.enumerateInstances();
        while (enum1.hasMoreElements()) {
            Instance inst = (Instance) enum1.nextElement();
            drawData.add(inst);
        }
        try {
            classifier.buildClassifier(initInstances);
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        drawRules(classifier);
        draw.redraw();
        draw.repaint();
        int[] dist = new int[gen.getDatasetFormat().classAttribute().numValues()];

        long all = 0;
        long correct = 0;
        long correct2 = 0;
        long step = 5;
        double timesum = 0;

        while (pause) {
            synchronized (classifier) {
                try {
                    classifier.wait();
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                if (breakRun)
                    return;
            }
        }
        int i = 0;
        while (true)  {
            i++;
            // if (i==6000) gen.init();
            Instance inst = gen.generateExample(i);
            inst.setDataset(initInstances);
            dist[(int) inst.classValue()]++;
            drawData.add(inst);
            int cls = 0;
            try {
                cls = (int) classifier.classifyInstance(inst);
            } catch (Exception e) {
                e.printStackTrace();
            }
            all++;

            if (cls == (int) inst.classValue())
                correct++;
            if (cls == gen.getLabel(inst))
                correct2++;
            long time1 = System.nanoTime();
            classifier.updateClassifier(inst);
            long time2 = System.nanoTime();
            timesum += ((time2 - time1) / 1000000.0);
            if (i % step == 0) {
                drawRules(classifier);
                draw.redraw();
                draw.repaint();

                // System.out.print(i + ": ");
                // if (classifier instanceof RuleBasedAlgorithm) {
                // System.out.print(((RuleBasedAlgorithm) classifier)
                // .getRuleCount()
                // + " ");
                // }
                // System.out.println(+((CaseBasedAlgorithm) classifier)
                // .getTrainInstancesCount()
                // + " "
                // + (timesum / i)
                // + " "
                // + ((time2 - time1) / 1000000.0)
                // + " : "
                // + (correct / (double) all)
                // + " ("
                // + correct
                // + "/"
                // + all + ") " + (correct2 / (double) all));

                // for (int c = 0; c < dist.length; c++) {
                // System.out.print(" " + c + ":" + dist[c]);
                // }
                // System.out.println();

                probfield.setText(format
                        .format((100.0 * correct2 / (double) all))
                        + "%");

                if (stepping) {
                    stepping = false;
                    pause = true;
                }
                while (pause) {
                    synchronized (classifier) {
                        try {
                            classifier.wait();
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                        if (breakRun)
                            return;
                    }
                }
            }
        }
    }

    public static synchronized void test1() {
        try {

            do {

                minmax = new double[] {
                        gen.defineDataFormat().attribute(1)
                                .getLowerNumericBound(),
                        gen.defineDataFormat().attribute(1)
                                .getUpperNumericBound(),
                        gen.defineDataFormat().attribute(2)
                                .getLowerNumericBound(),
                        gen.defineDataFormat().attribute(2)
                                .getUpperNumericBound() };

                draw.setMinMaxX(minmax[0], minmax[1]);
                draw.setMinMaxY(minmax[2], minmax[3]);

                List li = new ArrayList();
                li.add(new Integer(1));
                li.add(new Integer(2));
                classifier.setOperativeAttributes(li);

                pause = true;
                stepping = false;
                runAll();
                breakRun = false;
            } while (!stopAll);

        } catch (Exception e2) {
            e2.printStackTrace();
        }
    }

    public static void markRule(SimpleConjunctiveRule r1) {
        double[] range1 = r1.getNumericRange(1);
        double[] range2 = r1.getNumericRange(2);
        markedRules.add(new double[] { range1[0], range1[1], range2[0],
                range2[1], r1.getClassValue() });
    }

    static double eps = 125;

    public static void drawRules(OnLineClassifier classifier) {
        ruleData.clear();
        if (classifier instanceof RuleBasedAlgorithm) {
            List rules = ((RuleBasedAlgorithm) classifier).getRules();
            if (rules != null) {
                Iterator it = rules.iterator();
                while (it.hasNext()) {
                    SimpleConjunctiveRule rule = (SimpleConjunctiveRule) it
                            .next();
                    double[] range1 = rule.getNumericRange(1);
                    double[] range2 = rule.getNumericRange(2);
                    if (range1==null || range2==null) continue;
                    if (rule.getDistributionSum() > 1)
                        ruleData.add(new double[] { range1[0], range1[1],
                                range2[0], range2[1], rule.getClassValue() });
                    else
                        ruleData.add(new double[] {
                                range1[0] - (minmax[1] - minmax[0]) / eps,
                                range1[1] + (minmax[1] - minmax[0]) / eps,
                                range2[0] - (minmax[3] - minmax[2]) / eps,
                                range2[1] + (minmax[3] - minmax[2]) / eps,
                                rule.getClassValue() });
                }
            }
        }
        drawData = ((CaseBasedAlgorithm) classifier).getTrainInstances();
    }

    public static void view() {
        JFrame fr;
        fr = new JFrame("Demonstration: Online Classification");
        fr.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        fr.getContentPane().setSize(550, 560);
        fr.setSize(550, 560);
        view(fr.getContentPane());

        
        fr.setVisible(true);
    }

    public static void view(final Container con) {

        draw = new DrawField2D(con.getWidth(), con.getHeight() - 50) {

            public void redraw() {
                draw();
            }
        };

        JPanel pan = new JPanel();
        pan.setLayout(new BorderLayout());
        pan.add(draw, "Center");
        JPanel buttons = new JPanel();

        gen = new GeneratorMeans(5, 2, 0.5);
        gen.setNoise(0.05);
        classifier = new IBLDS(5000, 50, 45, 5, 0.25, 4, 100, 10,true);

        final String[] vals = new String[] { "IBL-DS", "RL","RL6", "Win400","LWF","TWF","LWF2" };
        JComboBox cls = new JComboBox(vals);
        cls.addItemListener(new ItemListener() {

            public void itemStateChanged(ItemEvent e) {
                if(e.getStateChange()!=ItemEvent.SELECTED) return;
                if (!pause)
                    pause = true;
                OnLineClassifier old = classifier;
                Object id = e.getItem();
                if (id.equals(vals[0])) {
                    classifier = new IBLDS(5000, 50, 45, 5, 0.25, 4,
                            100, 10,true);
                } else if (id.equals(vals[1])) {
                    classifier = new RBLDS();
                } else if (id.equals(vals[2])) {
                    classifier = new RBLDS7(1000, 300, false, 100, 20, 5, 50, 10, 10, 0.5,
                            0.25);
                }else if (id.equals(vals[3])) {
                    classifier = new SlidingWindowIBk(400);
                } else if (id.equals(vals[4])) {
                    classifier = new LWF(0.04);
                } else if (id.equals(vals[5])) {
                    classifier = new TWF(0.996);
                } else if (id.equals(vals[6])) {
                    classifier = new LWF2(0.2);
                }
                gen.reset();
                breakRun = true;
                synchronized (old) {
                    old.notifyAll();
                }
            }

        });
        buttons.add(cls);

        final String[] dvals = new String[] { "Means", "Sine2", "Random",
                "Distrib", "Switch" };
        JComboBox dats = new JComboBox(dvals);
        dats.addItemListener(new ItemListener() {

            public void itemStateChanged(ItemEvent e) {
                if(e.getStateChange()!=ItemEvent.SELECTED) return;
                if (!pause)
                    pause = true;
                Object id = e.getItem();
                if (id.equals(dvals[0])) {
                    gen = new GeneratorMeans(5, 2, 0.5);
                } else if (id.equals(dvals[1])) {
                    gen = new GenSINE2();
                } else if (id.equals(dvals[2])) {
                    gen = new GeneratorRandom();
                } else if (id.equals(dvals[3])) {
                    gen = new GeneratorRectDist();
                } else if (id.equals(dvals[4])) {
                    gen = new GeneratorRectSwitch();
                }
                gen.setNoise(0.05);
                breakRun = true;
                synchronized (classifier) {
                    classifier.notifyAll();
                }

            }

        });
        buttons.add(dats);

        JButton but = new JButton("redraw");
        but.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                drawRules(classifier);
                draw.redraw();
                draw.repaint();
            }

        });
        buttons.add(but);
        JButton pau = new JButton("pause/resume");
        pau.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                pause = !pause;
                if (!pause)
                    synchronized (classifier) {
                        classifier.notifyAll();
                    }
            }

        });
        buttons.add(pau);

        JButton ste = new JButton("step");
        ste.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                stepping = true;
                if (pause)
                    pause = false;
                synchronized (classifier) {
                    classifier.notifyAll();
                }
            }

        });
        buttons.add(ste);

        format = new DecimalFormat("##0.00");
        probfield = new JTextField("100.00%", 6);
        buttons.add(probfield);

        pan.add(buttons, "South");
        con.add(pan);

        Thread th = new Thread() {
            public void run() {
                test1();
            }
        };
        th.start();
    }

    public static void draw() {
        draw.clear();
        if (gen != null) {
            int steps = 50;
            double stepX = (minmax[1] - minmax[0]) / steps;
            double stepY = (minmax[3] - minmax[2]) / steps;
            double posX = minmax[0];
            for (int x = 0; x <= steps; x++) {
                double posY = minmax[2];
                for (int y = 0; y <= steps; y++) {
                    double[] values = new double[] { 0, posX, posY, 0 };
                    values[3] = gen.getLabel(new Instance(1.0, values));
                    Instance inst = new Instance(1.0, values);
                    int val = (int) inst.value(3);
                    if (val >= 0)
                        draw.markPoint(inst.value(1), inst.value(2), cols[val],
                                5, DrawField2D.POINT);
                    posY += stepY;
                }
                posX += stepX;
            }
        }
        Iterator it = drawData.iterator();
        while (it.hasNext()) {
            Instance inst = (Instance) it.next();
            int val = (int) inst.value(3);
            if (val < 0)
                draw.markPoint(inst.value(1), inst.value(2), cols[val], 7,
                        DrawField2D.CROSS);
            else
                draw.markPoint(inst.value(1), inst.value(2), cols[val], 9,
                        DrawField2D.POINT);
        }
        it = ruleData.iterator();
        while (it.hasNext()) {
            double[] rule = (double[]) it.next();
            draw.drawRect(rule[0], rule[2], rule[1], rule[3], 2,
                    cols[(int) rule[4]]);
        }
        it = markedData.iterator();
        while (it.hasNext()) {
            Instance inst = (Instance) it.next();
            int val = (int) inst.value(3);
            if (val == 0)
                draw.markPoint(inst.value(1), inst.value(2), Color.CYAN, 5,
                        DrawField2D.POINT);
            else
                draw.markPoint(inst.value(1), inst.value(2), Color.CYAN, 5,
                        DrawField2D.CROSS);
        }
        it = markedRules.iterator();
        while (it.hasNext()) {
            double[] rule = (double[]) it.next();
            draw.drawRect(rule[0], rule[2], rule[1], rule[3], 4, Color.CYAN);
        }
    }

    public static void main(String[] args) {
        // gen = new GeneratorHyperplane(2,2,0.5);
        // gen = new GeneratorRecht();
        // gen = new GeneratorEllipseSwitch();
        // gen = new GeneratorRectDist();
        // gen = new GeneratorRectSwitch();
        // gen = new GeneratorRectStatic();
        // gen = new GeneratorRandom();
        // gen = new GeneratorEllipse();

        // classifier = new SlidingWindowIBk(50);
        view();
        // test1();

    }
    
    public void run(){
        view();
    }

}