/*
 * Created on 15.07.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package applications.pipes;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.Random;

import javax.swing.JFrame;
import javax.swing.JSplitPane;

import pipes.Blocker;
import pipes.Blocker2;
import pipes.ClusterVisualizer;
import pipes.ClusteringSaver;
import pipes.ClusteringStateLoader;
import pipes.CompareFuzzyClustering;
import pipes.CompareFuzzyClustering2;
import pipes.CompareFuzzyClustering5;
import pipes.CompareFuzzyClustering6;
import pipes.DFTNormWeightedStreams;
import pipes.FuzzyStreamCluster;
import pipes.FuzzyStreamingKMeans;
import pipes.FuzzyTrivialKMeans;
import pipes.IDFTStreams;
import pipes.LoadStreams;
import pipes.MultiSource;
import pipes.MultipleSource;
import pipes.NormWeightedStreams;
import pipes.NullSink;
import pipes.SaveObjectStream;
import pipes.SaveRealStreamsARFF;
import pipes.StreamVisualizer;
import pipes.data.SyntheticRealIterators.FactoryFunction;
import xxl.core.collections.queues.ArrayQueue;
import xxl.core.functions.Function;
import xxl.core.pipes.operators.identities.BufferPipe;
import xxl.core.pipes.scheduler.Controllable;
import xxl.core.pipes.scheduler.RoundRobinStrategy;
import xxl.core.pipes.scheduler.StrategyProcessor;
import xxl.core.pipes.sources.Source;
import clustering.FuzzyAverages;
import clustering.FuzzyKMeans;
import clustering.FuzzyKMeansUtils;
import clustering.KMeansUtils;
import clustering.RelativeFuzzyKMeans;

/**
 * @author beringer
 */
public class SimpleStreaming {
    // protected static String dir = "/home/nis/jberinge/results/parallelFKM/";
    protected static String dir = "D:/work/Research/parallelFKM/";

    // protected static String data128_16 =
    // "/home/nis/jberinge/datasets/data128_16.arff";

    protected static String data128_16 = "D:/work/datasets/fcl/data128_16.arff";

    protected static String fileNon = dir + "clustering.bin";

    protected static String fileNon6 = dir + "clustering6.bin";

    protected static String fileTrivial = dir + "clusteringTrivial.bin";

    protected static String fileDFT = dir + "clusteringDFT";

    protected static String fileNonDFT = dir + "clusteringNonDFT";

    protected static String fileQual = dir + "clQual";

    protected static int[] dfts = new int[] { 500, 250, 100, 50, 25, 10, 5, 2,
            1, 1000, 750 };

    protected static int d = 8;

    protected static int v = 9;

    public static void main(String[] args) {
        storeNonDFTClustering();
        // clusterCompSave(dfts[d]);
        // clusterCompSaveNT();
        // test5();
        // testNonDFT();
        // saveNonDFT();
        // compareDFT();
        // compareAll();
        // clusterSave();
        // compareAllSaved(1000);
        // clusterNonaSave();
        // trivialSave();
        // compareTrivial();
        // cpNonDFTTrivial();
        // compareSaved();
        // saveStreams();
    }

    public static void test2() {
        int count = 25;
        int blockSize = 128;
        int blockCount = 8;
        int dftCount = 40;
        // int classes= 2;
        // int diffClasses= 4;
        int maxClasses = 5;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
        }
        // final double[] pert= new double[] { 2.37, 2.37, 2.37 / 2 };
        // final double[] offt= new double[] { 0.0, 2.17, 3.925 };
        final double[] pert = new double[] { 3.97, 3.97, 3.97 / 2 };
        final double[] offt = new double[] { 0.0, 3.14, 0.0 };

        Function[] func = MultiSource.getFunctions(count, windowSize,
                blockSize, pert, offt);
        // Function[] addfunc= MultiSource.getEpsFunctions(count, windowSize,
        // 0.10, 0.25, 20, 50);
        // Function[] distortfunc= MultiSource.getEpsFunctions(count,
        // windowSize, -40.0, 40.5, 3.2, 7.8);
        Function[] addfunc = MultiSource.getEpsFunctions(count, windowSize,
                0.10, 0.25, 20, 50);
        Function[] distortfunc = MultiSource.getEpsFunctions(count, windowSize,
                -40.0, 40.5, 3.2, 7.8);
        final MultiSource ms = new MultiSource(MultiSource
                .getFunctionalFactory(count, func, addfunc, distortfunc),
                count, 12, blockSize * blockCount);
        ms.setCloseMode(Source.AUTOMATIC_CLOSE);

        Blocker bl = new Blocker(count, blockSize);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        int x = Toolkit.getDefaultToolkit().getScreenSize().width;

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        IDFTStreams istr3 = new IDFTStreams(obsStreams, count, blockSize
                * blockCount /* 128 */
        , dftCount, 1f /* (1f/(double)Math.sqrt(blockSize * blockCount/128f)) */
        );

        istr3.addSource(dft, 0);
        dft.subscribe(istr3, 0);

        int l1 = 0, l2 = 0;

        if (x > 1024) {
            l1 = 1070;
            l2 = 750;
        } else if (x > 800) {
            l1 = 810;
            l2 = 550;
        } else {
            l1 = 620;
            l2 = 330;
        }

        StreamVisualizer sv = new StreamVisualizer(obsStreams, blockSize
                * blockCount, l1, 75, 2f);
        sv.addSource(dc, 0);
        dc.subscribe(sv, 0);
        sv.createFrame("Input");

        StreamVisualizer sv3 = new StreamVisualizer(obsStreams, blockSize
                * blockCount, l2, 75, 2f);
        sv3.addSource(istr3, 0);
        istr3.subscribe(sv3, 0);
        sv3.createFrame("DFT-Streams");

        FuzzyStreamCluster wcs = new FuzzyStreamCluster(obsStreams, count,
                blockCount, dftCount, maxClasses, 2, 2, 2.0);
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 2, 2.0,15.0);
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);
        /*
         * ClusterTimeVisualizer ctv=new
         * ClusterTimeVisualizer(obsStreams,classes,100); wcs.subscribe(ctv, 0);
         * ctv.addSource(wcs,0);
         */
        ClusterVisualizer cv = new ClusterVisualizer(obsStreams, maxClasses,
                true);
        wcs.subscribe(cv, 0);
        cv.addSource(wcs, 0);
        cv.createFrame("ClusterVisualizer");
        // sv.start();

        final Frame fr = new Frame("Cluster Control");

        fr.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                fr.setVisible(false);
                fr.dispose();
                System.exit(0);
            }
        });
        Button but2 = new Button("PAUSE");
        but2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().hasToPauseUntilWakeUp();
            }
        });
        Button but3 = new Button("RESUME");
        but3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().wakeUp();
            }
        });
        fr.setLayout(new FlowLayout());
        fr.add(but2);
        fr.add(but3);
        fr.pack();
        fr.setVisible(true);

        if (x > 1024) {
            sv.setBounds(0, 0, 1250, 510);
            sv3.setBounds(310, 510, 940, 450);
            cv.setBounds(0, 510, 310, 250);
            fr.setLocation(20, 765);
        } else if (x > 800) {
            sv.setBounds(0, 0, 1000, 405);
            sv3.setBounds(300, 405, 700, 300);
            cv.setBounds(0, 405, 300, 250);
            fr.setLocation(10, 660);
        } else {
            sv.setBounds(0, 0, 800, 300);
            sv3.setBounds(310, 300, 490, 270);
            cv.setBounds(0, 300, 310, 200);
            fr.setLocation(0, 500);
        }
        ms.open();
    }

    public static void test3() {
        int count = 25;
        int blockSize = 128;
        int blockCount = 8;
        int dftCount = 40;
        // int classes= 2;
        // int diffClasses= 4;
        int maxClasses = 5;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
        }
        // final double[] pert= new double[] { 2.37, 2.37, 2.37 / 2 };
        // final double[] offt= new double[] { 0.0, 2.17, 3.925 };
        final double[] pert = new double[] { 3.97, 3.97, 3.97 / 2 };
        final double[] offt = new double[] { 0.0, 3.14, 0.0 };

        Function[] func = MultiSource.getFunctions(count, windowSize,
                blockSize, pert, offt);
        // Function[] addfunc= MultiSource.getEpsFunctions(count, windowSize,
        // 0.10, 0.25, 20, 50);
        // Function[] distortfunc= MultiSource.getEpsFunctions(count,
        // windowSize, -40.0, 40.5, 3.2, 7.8);
        Function[] addfunc = MultiSource.getEpsFunctions(count, windowSize,
                0.10, 0.25, 20, 50);
        Function[] distortfunc = MultiSource.getEpsFunctions(count, windowSize,
                -40.0, 40.5, 3.2, 7.8);
        final MultiSource ms = new MultiSource(MultiSource
                .getFunctionalFactory(count, func, addfunc, distortfunc),
                count, 12, blockSize * blockCount);
        ms.setCloseMode(Source.AUTOMATIC_CLOSE);

        Blocker bl = new Blocker(count, blockSize);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        int x = Toolkit.getDefaultToolkit().getScreenSize().width;
        int y = Toolkit.getDefaultToolkit().getScreenSize().height;

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        IDFTStreams istr3 = new IDFTStreams(obsStreams, count, blockSize
                * blockCount /* 128 */
        , dftCount, 1f /* (1f/(double)Math.sqrt(blockSize * blockCount/128f)) */
        );

        istr3.addSource(dft, 0);
        dft.subscribe(istr3, 0);

        int l1 = 0, l2 = 0;

        if (x > 1024) {
            l1 = 1070;
            l2 = 750;
        } else if (x > 800) {
            l1 = 810;
            l2 = 550;
        } else {
            l1 = 620;
            l2 = 330;
        }

        StreamVisualizer sv = new StreamVisualizer(obsStreams, blockSize
                * blockCount, l1, 100, 2f);
        sv.addSource(dc, 0);
        dc.subscribe(sv, 0);
        // JScrollPane com= new JScrollPane(sv.getComponent());
        ScrollPane com = sv.getScrollPane();

        StreamVisualizer sv3 = new StreamVisualizer(obsStreams, blockSize
                * blockCount, l2, 100, 2f);
        sv3.addSource(istr3, 0);
        istr3.subscribe(sv3, 0);
        // JScrollPane com3= new JScrollPane(sv3.getComponent());
        ScrollPane com3 = sv3.getScrollPane();

        FuzzyStreamCluster wcs =
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 2, 2.0);
        new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
                maxClasses, 2, 2, 2.0);
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);
        /*
         * ClusterTimeVisualizer ctv=new
         * ClusterTimeVisualizer(obsStreams,classes,100); wcs.subscribe(ctv, 0);
         * ctv.addSource(wcs,0);
         */
        ClusterVisualizer cv = new ClusterVisualizer(obsStreams, maxClasses,
                true);
        wcs.subscribe(cv, 0);
        cv.addSource(wcs, 0);
        // JScrollPane comcv= new JScrollPane(cv.getComponent());
        ScrollPane comcv = cv.getScrollPane();
        // sv.start();

        final Panel controlPanel = new Panel();

        Button but2 = new Button("PAUSE");
        but2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().hasToPauseUntilWakeUp();
            }
        });
        Button but3 = new Button("RESUME");
        but3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().wakeUp();
            }
        });
        controlPanel.setLayout(new FlowLayout());
        controlPanel.add(but2);
        controlPanel.add(but3);

        final JFrame fr = new JFrame("Control");

        fr.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                fr.setVisible(false);
                fr.dispose();
                System.exit(0);
            }
        });
        Panel pan = new Panel();
        pan.setLayout(new BorderLayout());
        pan.add("Center", comcv);
        pan.add("South", controlPanel);

        JSplitPane sp1 = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, pan,
                com3);
        sp1.setDividerLocation(0.5);
        sp1.setBorder(null);
        JSplitPane sp2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, com,
                sp1);
        sp2.setDividerLocation(0.5);
        sp2.setBorder(null);
        sp1.setMinimumSize(new Dimension(20, 20));
        sp2.setMinimumSize(new Dimension(20, 20));
        sp1.setOneTouchExpandable(false);
        sp1.setContinuousLayout(false);
        sp2.setOneTouchExpandable(false);
        sp2.setContinuousLayout(false);
        fr.getContentPane().add(sp2);
        // fr.pack();
        fr.setSize(x, y - 60);
        fr.setVisible(true);
        /*
         * if (x > 1024) { sv.setBounds(0, 0, 1250, 510); sv3.setBounds(310,
         * 510, 940, 450); cv.setBounds(0, 510, 310, 250);
         * controlPanel.setLocation(20, 765); } else if (x > 800) {
         * sv.setBounds(0, 0, 1000, 405); sv3.setBounds(300, 405, 700, 300);
         * cv.setBounds(0, 405, 300, 250); controlPanel.setLocation(10, 660); }
         * else { sv.setBounds(0, 0, 800, 300); sv3.setBounds(310, 300, 490,
         * 270); cv.setBounds(0, 300, 310, 200); controlPanel.setLocation(0,
         * 500); }
         */
        sp1.setDividerLocation(0.5);
        sp2.setDividerLocation(0.5);
        com.doLayout();
        com3.doLayout();
        ms.open();
    }

    public static MultipleSource getSource(int period) {
        int count = 100;
        int blockSize = 128;

        Random random = new Random(161752783);
        FactoryFunction generator = new FactoryFunction(6, count, blockSize,
                random);
        final MultiSource ms = new MultiSource(generator, count, period,
                blockSize);
        ms.setCloseMode(Source.AUTOMATIC_CLOSE);
        return ms;
    }

    public static MultipleSource getSource2(int period) {
        int blockSize = 128;

        MultipleSource ms = null;
        try {
            ms = new LoadStreams(data128_16, blockSize, period);
            ms.setCloseMode(Source.AUTOMATIC_CLOSE);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return ms;
    }

    public static void test5() {
        int count = 60;
        int blockSize = 128;
        int blockCount = 16;
        int dftCount = 500;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource(1000);
        // VisualizeStreams visStreams = new VisualizeStreams("Streams", count,
        // obsStreams, lengths, autosize, min, max, 0, null, null);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);

            // ms.subscribe(visStreams, i);
            // visStreams.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        int x = Toolkit.getDefaultToolkit().getScreenSize().width;
        int y = Toolkit.getDefaultToolkit().getScreenSize().height;

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        IDFTStreams istr3 = new IDFTStreams(obsStreams, count, blockSize
                * blockCount /* 128 */
        , dftCount, 1f /* (1f/(double)Math.sqrt(blockSize * blockCount/128f)) */
        );

        istr3.addSource(dft, 0);
        dft.subscribe(istr3, 0);

        // int l1 = 0;
        int l2 = 0;

        if (x > 1024) {
            // l1 = 1070;
            l2 = 750;
        } else if (x > 800) {
            // l1 = 810;
            l2 = 550;
        } else {
            // l1 = 620;
            l2 = 330;
        }

        StreamVisualizer sv3 = new StreamVisualizer(obsStreams, blockSize
                * blockCount, l2, 100, 2f);
        sv3.addSource(istr3, 0);
        istr3.subscribe(sv3, 0);
        // JScrollPane com3= new JScrollPane(sv3.getComponent());
        ScrollPane com3 = sv3.getScrollPane();

        FuzzyStreamCluster wcs =
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 6, 2.0);
        new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
                maxClasses, 2, 2, 2.0, 0.0);
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);
        /*
         * ClusterTimeVisualizer ctv=new
         * ClusterTimeVisualizer(obsStreams,classes,100); wcs.subscribe(ctv, 0);
         * ctv.addSource(wcs,0);
         */
        ClusterVisualizer cv = new ClusterVisualizer(obsStreams, maxClasses,
                true);
        wcs.subscribe(cv, 0);
        cv.addSource(wcs, 0);
        // JScrollPane comcv= new JScrollPane(cv.getComponent());
        ScrollPane comcv = cv.getScrollPane();
        // sv.start();

        final Panel controlPanel = new Panel();

        Button but2 = new Button("PAUSE");
        but2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().hasToPauseUntilWakeUp();
            }
        });
        Button but3 = new Button("RESUME");
        but3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().wakeUp();
            }
        });
        controlPanel.setLayout(new FlowLayout());
        controlPanel.add(but2);
        controlPanel.add(but3);

        final JFrame fr = new JFrame("Control");

        fr.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                fr.setVisible(false);
                fr.dispose();
                System.exit(0);
            }
        });
        Panel pan = new Panel();
        pan.setLayout(new BorderLayout());
        pan.add("Center", comcv);
        pan.add("South", controlPanel);

        JSplitPane sp1 = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, pan,
                com3);
        sp1.setDividerLocation(0.3);
        sp1.setBorder(null);

        sp1.setMinimumSize(new Dimension(20, 20));
        sp1.setOneTouchExpandable(false);
        sp1.setContinuousLayout(false);
        fr.getContentPane().add(sp1);
        // fr.pack();
        fr.setSize(x, y - 60);
        fr.setVisible(true);
        /*
         * if (x > 1024) { sv.setBounds(0, 0, 1250, 510); sv3.setBounds(310,
         * 510, 940, 450); cv.setBounds(0, 510, 310, 250);
         * controlPanel.setLocation(20, 765); } else if (x > 800) {
         * sv.setBounds(0, 0, 1000, 405); sv3.setBounds(300, 405, 700, 300);
         * cv.setBounds(0, 405, 300, 250); controlPanel.setLocation(10, 660); }
         * else { sv.setBounds(0, 0, 800, 300); sv3.setBounds(310, 300, 490,
         * 270); cv.setBounds(0, 300, 310, 200); controlPanel.setLocation(0,
         * 500); }
         */
        sp1.setDividerLocation(0.3);
        com3.doLayout();
        ms.open();
    }

    public static void testNonDFT() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        int x = Toolkit.getDefaultToolkit().getScreenSize().width;
        int y = Toolkit.getDefaultToolkit().getScreenSize().height;

        NormWeightedStreams dft = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        // int l1 = 0;
        int l2 = 0;

        if (x > 1024) {
            // l1 = 1070;
            l2 = 750;
        } else if (x > 800) {
            // l1 = 810;
            l2 = 550;
        } else {
            // l1 = 620;
            l2 = 330;
        }

        StreamVisualizer sv3 = new StreamVisualizer(obsStreams, blockSize
                * blockCount, l2, 100, 2f);
        sv3.addSource(dft, 0);
        dft.subscribe(sv3, 0);
        // JScrollPane com3= new JScrollPane(sv3.getComponent());
        ScrollPane com3 = sv3.getScrollPane();

        FuzzyStreamCluster wcs = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 2);
        // wcs.minClusterCount=6;
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);
        /*
         * ClusterTimeVisualizer ctv=new
         * ClusterTimeVisualizer(obsStreams,classes,100); wcs.subscribe(ctv, 0);
         * ctv.addSource(wcs,0);
         */
        ClusterVisualizer cv = new ClusterVisualizer(obsStreams, maxClasses,
                true);
        wcs.subscribe(cv, 0);
        cv.addSource(wcs, 0);
        // JScrollPane comcv= new JScrollPane(cv.getComponent());
        ScrollPane comcv = cv.getScrollPane();
        // sv.start();

        final Panel controlPanel = new Panel();

        Button but2 = new Button("PAUSE");
        but2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().hasToPauseUntilWakeUp();
            }
        });
        Button but3 = new Button("RESUME");
        but3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ms.getProcessor().wakeUp();
            }
        });
        controlPanel.setLayout(new FlowLayout());
        controlPanel.add(but2);
        controlPanel.add(but3);

        final JFrame fr = new JFrame("Control");

        fr.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                fr.setVisible(false);
                fr.dispose();
                System.exit(0);
            }
        });
        Panel pan = new Panel();
        pan.setLayout(new BorderLayout());
        pan.add("Center", comcv);
        pan.add("South", controlPanel);

        JSplitPane sp1 = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, pan,
                com3);
        sp1.setDividerLocation(0.3);
        sp1.setBorder(null);

        sp1.setMinimumSize(new Dimension(20, 20));
        sp1.setOneTouchExpandable(false);
        sp1.setContinuousLayout(false);
        fr.getContentPane().add(sp1);
        // fr.pack();
        fr.setSize(x, y - 60);
        fr.setVisible(true);
        /*
         * if (x > 1024) { sv.setBounds(0, 0, 1250, 510); sv3.setBounds(310,
         * 510, 940, 450); cv.setBounds(0, 510, 310, 250);
         * controlPanel.setLocation(20, 765); } else if (x > 800) {
         * sv.setBounds(0, 0, 1000, 405); sv3.setBounds(300, 405, 700, 300);
         * cv.setBounds(0, 405, 300, 250); controlPanel.setLocation(10, 660); }
         * else { sv.setBounds(0, 0, 800, 300); sv3.setBounds(310, 300, 490,
         * 270); cv.setBounds(0, 300, 310, 200); controlPanel.setLocation(0,
         * 500); }
         */
        sp1.setDividerLocation(0.3);
        com3.doLayout();
        ms.open();
    }

    public static void saveStreams() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource(200);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        SaveRealStreamsARFF ss;
        try {
            ss = new SaveRealStreamsARFF(data128_16, "data128_16", count,
                    obsStreams);
            ss.addSource(dc, 0);
            dc.subscribe(ss, 0);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        ms.open();
    }

    public static void saveNonDFT() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
        }

        final MultipleSource ms = getSource2(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams dft = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        FuzzyStreamCluster wcs = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, 6, 2, 2);
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        FuzzyStreamCluster.QUIET = false;

        wcs.setBufferPipe(dc);
        ClusteringSaver save2 = new ClusteringSaver(fileNon, false);

        wcs.subscribe(save2, 0);
        save2.addSource(wcs, 0);

        ms.open();
    }

    public static void cpNonDFTTrivial() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        double[][] cluster = new double[count][6];
        double[][] kMeans = new double[6][windowSize];
        int cl = 0;
        for (int i = 0; i < count; i++) {
            cluster[i][cl] = 1.0;
            cl = (cl + 1) % 6;
            obsStreams[i] = "Stream Nr." + i;
        }

        final MultipleSource ms = getSource2(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams dft = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        FuzzyStreamCluster wcs = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, 6, 2, 2);
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        ClusteringSaver save2 = new ClusteringSaver(fileNon, false);

        wcs.subscribe(save2, 0);
        save2.addSource(wcs, 0);

        FuzzyStreamCluster.QUIET = false;

        wcs.setBufferPipe(dc);

        FuzzyTrivialKMeans wcs2 = new FuzzyTrivialKMeans(
                new RelativeFuzzyKMeans(new FuzzyKMeans(KMeansUtils
                        .getDoubleDistance(windowSize), 2.0,
                        FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                        FuzzyKMeansUtils.INITALIZE, KMeansUtils
                                .getDoubleCopyFunction(windowSize),
                        FuzzyAverages.getDoubleMeansFunction(windowSize))),
                obsStreams, count, blockCount, 6, cluster, kMeans);
        dft.subscribe(wcs2, 0);
        wcs2.addSource(dft, 0);

        ClusteringSaver saveT = new ClusteringSaver(fileTrivial, false);

        wcs2.subscribe(saveT, 0);
        saveT.addSource(wcs2, 0);

        wcs2.setBufferPipe(dc);

        CompareFuzzyClustering2 comp = new CompareFuzzyClustering2(
                new PrintWriter(System.out), count, false, KMeansUtils
                        .getDoubleDistance(windowSize));

        dft.subscribe(comp, 3);
        comp.addSource(dft, 3);

        wcs.subscribe(comp, 0);
        comp.addSource(wcs, 0);

        wcs2.subscribe(comp, 1);
        comp.addSource(wcs2, 1);

        ms.open();
    }

    public static void compareAll() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int dftCount = 50;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(dc, 0);
        dc.subscribe(nws, 0);

        FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 2);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        wcs2.setBufferPipe(dc);

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        FuzzyStreamCluster wcs =
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 6, 2.0);
        new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
                maxClasses, 2, 2, 2.0, 0.0);

        CompareFuzzyClustering comp = new CompareFuzzyClustering(
                new PrintWriter(System.out), new PrintWriter(System.out),
                new PrintWriter(System.out), new PrintWriter(System.out),
                new PrintWriter(System.out), wcs.getFKMC(), count, dftCount,
                windowSize);

        nws.subscribe(comp, 4);
        comp.addSource(nws, 4);

        dft.subscribe(comp, 3);
        comp.addSource(dft, 3);

        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);

        wcs.subscribe(comp, 0);
        comp.addSource(wcs, 0);

        wcs2.subscribe(comp, 5);
        comp.addSource(wcs2, 5);

        // ClusteringSaver save = new ClusteringSaver(fileNon, false);
        //
        // wcs2.subscribe(save, 0, 0);
        // save.addSource(wcs2, 0);
        // wcs2.subscribe(save, 1, 1);
        // save.addSource(wcs2, 1);
        // wcs2.subscribe(save, 2, 2);
        // save.addSource(wcs2, 2);

        ClusteringSaver save2 = new ClusteringSaver(fileDFT, true);

        wcs.subscribe(save2, 0);
        save2.addSource(wcs, 0);

        ms.open();
    }

    public static void storeNonDFTClustering() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int dftCount = 50;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(dc, 0);
        dc.subscribe(nws, 0);

        FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 6);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        wcs2.setBufferPipe(dc);

        SaveObjectStream save2 = null;
        try {
            save2 = new SaveObjectStream(fileNonDFT);
            save2.setMaxCount(250);
        } catch (IOException e) {
            e.printStackTrace();
        }

        wcs2.subscribe(save2, 0);
        save2.addSource(wcs2, 0);

        ms.open();
    }

    public static void doNonDFTClustering() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int dftCount = 50;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(dc, 0);
        dc.subscribe(nws, 0);

        FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 6);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        wcs2.setBufferPipe(dc);

        NullSink sink = new NullSink();
        wcs2.subscribe(sink, 0);
        sink.addSource(wcs2, 0);

        ms.open();
    }

    public static void doDFTClustering() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int dftCount = 50;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);

        FuzzyStreamCluster wcs =
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 6, 2.0);
        new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
                maxClasses, 2, 2, 2.0, 0.0);

        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);

        try {
            dft.timeWriter = new BufferedWriter(new FileWriter(fileDFT
                    + dftCount + ".txt"));
            wcs.timeWriter = new BufferedWriter(new FileWriter(fileDFT
                    + dftCount + "b.txt"));
        } catch (IOException e) {
            e.printStackTrace();
        }

        NullSink sink = new NullSink();
        wcs.subscribe(sink, 0);
        sink.addSource(wcs, 0);

        ms.open();
    }

    public static void rerun() {
        d++;
        if (d >= dfts.length) {
            v++;
            d = 0;
            if (v >= 10)
                System.exit(0);
        }
        System.out.println("d=" + d + "(" + dfts[d] + ")  v=" + v);
        clusterCompSave(dfts[d]);

        // v++;
        // if (v>=10) System.exit(0);
        // clusterCompSaveNT();
    }

    public static void clusterCompSave(int dftCount) {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        double[][] cluster = new double[count][6];
        double[][] kMeans = new double[6][windowSize];
        int cl = 0;
        for (int i = 0; i < count; i++) {
            cluster[i][cl] = 1.0;
            cl = (cl + 1) % 6;
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(200);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(bl, 0);
        bl.subscribe(dft, 0);

        FuzzyStreamCluster wcs = new FuzzyStreamCluster(obsStreams, count,
                blockCount, dftCount, maxClasses, 2, 2, 2.0, 0.0);

        FuzzyStreamingKMeans.QUIET = false;

        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(bl, 0);
        bl.subscribe(nws, 0);

        FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 2);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        FuzzyTrivialKMeans wcs3 = new FuzzyTrivialKMeans(
                new RelativeFuzzyKMeans(new FuzzyKMeans(KMeansUtils
                        .getDoubleDistance(windowSize), 2.0,
                        FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                        FuzzyKMeansUtils.INITALIZE, KMeansUtils
                                .getDoubleCopyFunction(windowSize),
                        FuzzyAverages.getDoubleMeansFunction(windowSize))),
                obsStreams, count, blockCount, 6, cluster, kMeans);
        nws.subscribe(wcs3, 0);
        wcs3.addSource(nws, 0);

        CompareFuzzyClustering5 comp = null;
        CompareFuzzyClustering6 comp6 = null;
        try {
            Writer ccout = new PrintWriter(System.out);
            FileWriter cc = new FileWriter(dir + "clusterCount" + dftCount
                    + ".txt", true);
            FileWriter cc2 = new FileWriter(dir + "clusterCountN.txt", true);
            FileWriter c1 = new FileWriter(dir + "compN" + dftCount + ".txt",
                    true);

            FileWriter c2 = new FileWriter(dir + "comp2N" + dftCount + ".txt",
                    true);

            comp = new CompareFuzzyClustering5(cc, cc2, c1, count);
            comp6 = new CompareFuzzyClustering6(ccout, ccout, c2, count);
        } catch (IOException e) {
            e.printStackTrace();
        }

        wcs.subscribe(comp, 0);
        comp.addSource(wcs, 0);

        wcs2.subscribe(comp, 1);
        comp.addSource(wcs2, 1);

        wcs.subscribe(comp6, 0);
        comp6.addSource(wcs, 0);

        wcs2.subscribe(comp6, 1);
        comp6.addSource(wcs2, 1);

        CompareFuzzyClustering5 compT = null;
        CompareFuzzyClustering6 compT6 = null;
        try {
            Writer cc = new PrintWriter(System.out);
            FileWriter cc2 = new FileWriter(dir + "clusterCountT.txt", true);
            FileWriter c1 = new FileWriter(dir + "compT" + dftCount + ".txt",
                    true);
            FileWriter c2 = new FileWriter(dir + "comp2T" + dftCount + ".txt",
                    true);

            compT = new CompareFuzzyClustering5(cc, cc2, c1, count);
            compT6 = new CompareFuzzyClustering6(cc, cc, c2, count);
        } catch (IOException e) {
            e.printStackTrace();
        }

        wcs.subscribe(compT, 0);
        compT.addSource(wcs, 0);

        wcs3.subscribe(compT, 1);
        compT.addSource(wcs3, 1);

        wcs.subscribe(compT6, 0);
        compT6.addSource(wcs, 0);

        wcs3.subscribe(compT6, 1);
        compT6.addSource(wcs3, 1);

        ms.open();
    }

    public static void clusterCompSaveNT() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        double[][] cluster = new double[count][6];
        double[][] kMeans = new double[6][windowSize];
        int cl = 0;
        for (int i = 0; i < count; i++) {
            cluster[i][cl] = 1.0;
            cl = (cl + 1) % 6;
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }

        FuzzyStreamingKMeans.QUIET = false;

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(bl, 0);
        bl.subscribe(nws, 0);

        FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 2);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        FuzzyTrivialKMeans wcs3 = new FuzzyTrivialKMeans(
                new RelativeFuzzyKMeans(new FuzzyKMeans(KMeansUtils
                        .getDoubleDistance(windowSize), 2.0,
                        FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                        FuzzyKMeansUtils.INITALIZE, KMeansUtils
                                .getDoubleCopyFunction(windowSize),
                        FuzzyAverages.getDoubleMeansFunction(windowSize))),
                obsStreams, count, blockCount, 6, cluster, kMeans);
        nws.subscribe(wcs3, 0);
        wcs3.addSource(nws, 0);

        CompareFuzzyClustering2 compT = null;
        try {
            Writer cc = new PrintWriter(System.out);
            FileWriter cc2 = new FileWriter(
                    "D:\\work\\Research\\parallelFKM\\compNT.txt", true);

            compT = new CompareFuzzyClustering2(cc, count, false, KMeansUtils
                    .getDoubleDistance(windowSize));
        } catch (IOException e) {
            e.printStackTrace();
        }

        wcs2.subscribe(compT, 0);
        compT.addSource(wcs2, 0);

        wcs3.subscribe(compT, 1);
        compT.addSource(wcs3, 1);

        ms.open();
    }

    public static void clusterSave() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int dftCount = 750;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(1200);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        // BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        // StrategyProcessor proc = new StrategyProcessor(new
        // RoundRobinStrategy(
        // new Controllable[] { dc }), 0, 2500);
        // proc.start();

        // NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
        // blockSize, blockCount, weight, bl.getFloatPool());
        // nws.addSource(dc, 0);
        // dc.subscribe(nws, 0);
        //
        // FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
        // KMeansUtils.getDoubleDistance(windowSize), 2.0,
        // FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF, FuzzyKMeans.INITALIZE,
        // KMeansUtils.getDoubleCopyFunction(windowSize), FuzzyAverages
        // .getDoubleMeansFunction(windowSize)), obsStreams,
        // count, blockCount, maxClasses, 2);
        // nws.subscribe(wcs2, 0);
        // wcs2.addSource(nws, 0);
        //
        // wcs2.setBufferPipe(dc);

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(bl, 0);
        bl.subscribe(dft, 0);

        FuzzyStreamCluster wcs =
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 6, 2.0);
        new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
                maxClasses, 2, 2, 2.0, 0.0);

        FuzzyStreamingKMeans.QUIET = false;

        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        // wcs.setBufferPipe(dc);

        // ClusteringSaver save = new ClusteringSaver(fileNon, false);
        //
        // wcs2.subscribe(save, 0, 0);
        // save.addSource(wcs2, 0);
        // wcs2.subscribe(save, 1, 1);
        // save.addSource(wcs2, 1);
        // wcs2.subscribe(save, 2, 2);
        // save.addSource(wcs2, 2);

        ClusteringSaver save2 = new ClusteringSaver(
                fileDFT + dftCount + ".bin", true);

        wcs.subscribe(save2, 0);
        save2.addSource(wcs, 0);

        ms.open();
    }

    public static void clusterNonSave() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        int maxClasses = 12;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(1500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        // BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        // StrategyProcessor proc = new StrategyProcessor(new
        // RoundRobinStrategy(
        // new Controllable[] { dc }), 0, 2500);
        //        
        // proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(bl, 0);
        bl.subscribe(nws, 0);

        FuzzyStreamCluster wcs2 = new FuzzyStreamCluster(new FuzzyKMeans(
                KMeansUtils.getDoubleDistance(windowSize), 2.0,
                FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                FuzzyKMeansUtils.INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(windowSize), FuzzyAverages
                        .getDoubleMeansFunction(windowSize)), obsStreams,
                count, blockCount, maxClasses, 2, 2);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        // wcs2.setBufferPipe(dc);

        FuzzyStreamingKMeans.QUIET = false;

        // ClusteringSaver save = new ClusteringSaver(fileNon, false);
        //
        // wcs2.subscribe(save, 0, 0);
        // save.addSource(wcs2, 0);
        // wcs2.subscribe(save, 1, 1);
        // save.addSource(wcs2, 1);
        // wcs2.subscribe(save, 2, 2);
        // save.addSource(wcs2, 2);

        ClusteringSaver save2 = new ClusteringSaver(fileNon, false);

        wcs2.subscribe(save2, 0);
        save2.addSource(wcs2, 0);

        ms.open();
    }

    public static void trivialSave() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        double[][] cluster = new double[count][6];
        double[][] kMeans = new double[6][windowSize];
        int cl = 0;
        for (int i = 0; i < count; i++) {
            cluster[i][cl] = 1.0;
            cl = (cl + 1) % 6;
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(500);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(dc, 0);
        dc.subscribe(nws, 0);

        FuzzyTrivialKMeans wcs2 = new FuzzyTrivialKMeans(
                new RelativeFuzzyKMeans(new FuzzyKMeans(KMeansUtils
                        .getDoubleDistance(windowSize), 2.0,
                        FuzzyKMeans.OBJECTIVE, FuzzyKMeans.MYVF3,
                        FuzzyKMeansUtils.INITALIZE, KMeansUtils
                                .getDoubleCopyFunction(windowSize),
                        FuzzyAverages.getDoubleMeansFunction(windowSize))),
                obsStreams, count, blockCount, 6, cluster, kMeans);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        wcs2.setBufferPipe(dc);

        FuzzyStreamingKMeans.QUIET = false;

        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        ClusteringSaver save2 = new ClusteringSaver(fileTrivial, false);

        wcs2.subscribe(save2, 0);
        save2.addSource(wcs2, 0);

        ms.open();
    }

    public static void compareAllSaved(int dftCount) {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(50);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 2, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(dc, 0);
        dc.subscribe(nws, 0);

        ClusteringStateLoader wcs2 = new ClusteringStateLoader(fileTrivial,
                false, blockCount + 1);
        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        ClusteringStateLoader wcs = new ClusteringStateLoader(fileDFT
                + dftCount + ".bin", true, blockCount + 1);

        CompareFuzzyClustering comp = null;
        // try {
        // comp = new CompareFuzzyClustering(
        // /* new PrintWriter(System.out) */new FileWriter(
        // "D:\\work\\Research\\parallelFKM\\compT" + dftCount
        // + ".txt"), new FuzzyKMeans(StreamCluster
        // .getDFTDistance(dftCount), 2.0, FuzzyKMeans.OBJECTIVE,
        // FuzzyKMeans.MYVF3, FuzzyKMeansUtils.INITALIZE, KMeansUtils
        // .getComplexCopyFunction(dftCount), FuzzyAverages
        // .getComplexMeansFunction(dftCount), -1), count,
        // dftCount, windowSize);
        // } catch (IOException e) {
        // e.printStackTrace();
        // }

        nws.subscribe(wcs, 0);
        wcs.addSource(nws, 0);

        wcs.subscribe(comp, 0);
        comp.addSource(wcs, 0);

        wcs2.subscribe(comp, 1);
        comp.addSource(wcs2, 1);

        ms.open();
    }

    public static void compareTrivial() {
        int count = 100;
        int blockSize = 128;
        int blockCount = 16;
        double lastWeight = 0.2;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize = blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths = new int[count];
        boolean[] autosize = new boolean[count];
        double[] min = new double[count];
        double[] max = new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i] = windowSize;
            autosize[i] = true;
            min[i] = 0;
            max[i] = 1;
        }

        final MultipleSource ms = getSource2(1000);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i, i);
            bl.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 0, new ArrayQueue(), 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        NormWeightedStreams nws = new NormWeightedStreams(obsStreams, count,
                blockSize, blockCount, weight, bl.getFloatPool());
        nws.addSource(dc, 0);
        dc.subscribe(nws, 0);

        ClusteringStateLoader wcs2 = new ClusteringStateLoader(fileNon, false,
                blockCount + 1);

        ClusteringStateLoader wcs = new ClusteringStateLoader(fileTrivial,
                false, blockCount + 1);

        CompareFuzzyClustering2 comp = null;
        try {
            comp = new CompareFuzzyClustering2(
            /* new PrintWriter(System.out) */new FileWriter(
                    "D:\\work\\Research\\parallelFKM\\compTN.txt"), count,
                    false, KMeansUtils.getDoubleDistance(windowSize));
        } catch (IOException e) {
            e.printStackTrace();
        }

        nws.subscribe(wcs, 0);
        wcs.addSource(nws, 0);

        nws.subscribe(wcs2, 0);
        wcs2.addSource(nws, 0);

        wcs.subscribe(comp, 0);
        comp.addSource(wcs, 0);

        wcs2.subscribe(comp, 1);
        comp.addSource(wcs2, 1);

        ms.open();
    }

}
