/*
 * Created on 03.07.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package clustering;

import xxl.core.functions.Function;

/**
 * @author beringer
 */
public class KMedian extends KMeans {

	protected static Distance getDistance(final double[][] distanceArray) {
		return new AbstractDistance() {
			public double squaredDistance(Object ob1, Object ob2) {
				int i1= ((Integer) ob1).intValue();
				int i2= ((Integer) ob2).intValue();
				if (i1 == i2)
					return 0.0;
				if (i1 < i2) {
					int help= i2;
					i2= i1;
					i1= help;
				}
				return distanceArray[i1][i2];
			}
		};
	}
	protected static Average getMeansFunction() {
		return new Average() {
            public Object average(KMeansClustering km,Object[] obs,int len,Object mean) {

				Distance dist= km.getDistance();

				double[] sumDist= new double[len];
				double val;
				for (int i= 0; i < len - 1; i++) {
					for (int j= i + 1; j < len; j++) {
						val= dist.distance(obs[i], obs[j]);
						sumDist[i] += val;
						sumDist[j] += val;
					}
				}
				int minIndex= 0;
				val= sumDist[0];
				for (int i= 1; i < len; i++) {
					if (sumDist[i] < val) {
						val= sumDist[i];
						minIndex= i;
					}
				}
				return obs[minIndex];

			}
		};
	}

	public static Function getCopyObjectFunction() {
		return new Function() {
			public Object invoke(Object ob1, Object ob2) {
				ob2= ob1;
				return ob2;
			}
		};

	}

	public static double[][] makeDistanceArray(Object[] data, int dataCount, xxl.core.util.Distance km) {
		double[][] dist= new double[dataCount][];
		for (int i= 1; i < dataCount; i++) {
			dist[i]= new double[i];
			for (int j= 0; j < i; j++) {
				dist[i][j]= km.distance(data[i], data[j]);
			}
		}
		return dist;
	}

	public static Object[] getData(int dataCount) {
		Object[] data= new Object[dataCount];
		for (int i= 0; i < dataCount; i++)
			data[i]= new Integer(i);
		return data;
	}

	double[][] distanceArray;
	int dataCount;

	public KMedian(double[][] distanceArray, int dataCount) {
		super(
			getDistance(distanceArray),
			KMeans.OBJECTIVE,
			KMeans.SEPARATION,
			KMeans.INITALIZE,
			getCopyObjectFunction(),
			getMeansFunction());
		this.distanceArray= distanceArray;
		this.dataCount= dataCount;
	}

	
	public KMeansState invokeKMedian(int clusterCount) {
		Object[] data= getData(dataCount);
		return invokeKMeans(data, dataCount, clusterCount);
	}

}
