/*
 * Created on 03.06.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package clustering;

import clustering.*;

/**
 * @author beringer
 */
public class RelativeKMeans {

    public static boolean QUIET = true;

    public static boolean DEBUG = false;

    static public int OBJECTIVE_CHOOSE = 0;

    static public int VALIDITY_CHOOSE = 1;

    // public int mode=OBJECTIVE_CHOOSE;
    public int mode = VALIDITY_CHOOSE;

    protected KMeans kmAlg;

    protected int testCount = 10;

    protected int[] testInd = new int[testCount];
    
    protected int[] kCounter;

    protected Object[][] bestMeans;

    protected double[] bestValidity;

    public RelativeKMeans(KMeans kmAlg) {
        this.kmAlg = kmAlg;
    }

    public KMeansState invokeRelativeKMeans(Object[] data, int dataCount,
            int minClusterCount, int maxClusterCount, int initClusterCount, double testpart) {
        
        if (testpart >= 1)
            testCount = (int) Math.round(testpart);
        else
            testCount = (int) Math.ceil(dataCount * testpart);
        testInd = new int[testCount];
        int clusterCount = initClusterCount;
        Object[] kmeans = new Object[maxClusterCount];
        
        kCounter = new int[maxClusterCount];
        bestMeans = new Object[maxClusterCount][];
        bestValidity = new double[maxClusterCount];

        int[] cluster = new int[dataCount];
        double[] clusterCounts = new double[dataCount];
        double[][] clusterSquaredDist = new double[dataCount][maxClusterCount];
        KMeansState state = new KMeansState(data, dataCount, clusterCount);
        state.clusterSquaredDist = clusterSquaredDist;
        state.clusterCounts = clusterCounts;
        state.cluster = cluster;
        state.maxClusterCount = maxClusterCount;
        state.minClusterCount = minClusterCount;
        state.kmc = kmAlg;
        state.kMeans = kmeans;
        kmAlg.initialize(state);
        kmAlg.computeMemberships(state);
        boolean hasChanged = false;
        int oldClusterCount;
        int dif = 0;

        do {
            kmAlg.computeClusterCenters(state);
            dif = kmAlg.computeMemberships(state);
        } while (dif > 0);

        do {
            oldClusterCount = clusterCount;
            clusterCount = testRemoveClusterCount(state, false);
        } while (oldClusterCount != clusterCount);
        int loop = 0;
        do {
            loop++;
            hasChanged = false;
            do {
                kmAlg.computeClusterCenters(state);
                dif = kmAlg.computeMemberships(state);
            } while (dif > 0);

            // Klassen lschen, hinzufgen
            oldClusterCount = clusterCount;
            clusterCount = testClusterCount(state);
            if (oldClusterCount != clusterCount) {
                hasChanged = true;
                kCounter[state.clusterCount]++;
                if (kCounter[state.clusterCount] >= 2) {
                    if (kCounter[state.clusterCount] == 2) {
                        bestMeans[state.clusterCount] = new Object[state.clusterCount];
                    }
                    if (kCounter[state.clusterCount] == 2
                            || bestValidity[state.clusterCount] > state.validity) {
                        copyMeans(state.kMeans,bestMeans[state.clusterCount],state.clusterCount);
                        bestValidity[state.clusterCount] = state.validity;
                    }
                    if (kCounter[state.clusterCount] >= 4){
                        int bestInd=0;
                        double bestVal=Double.MAX_VALUE;
                        for(int i=state.minClusterCount;i<=state.maxClusterCount;i++){
                            if (kCounter[i]>=2 && bestValidity[i]<bestVal){
                                bestInd=i;
                                bestVal=bestValidity[i];
                            }
                        }
                        state.clusterCount=bestInd;
                        copyMeans(bestMeans[bestInd],state.kMeans,bestInd);
                        kmAlg.computeMemberships(state);
                        hasChanged=false;
                    }
                }
            }
        } while (hasChanged && (loop < 1000));

        while (clusterCount < minClusterCount) {
            Object bestConf = testAddCluster(state, true);
            clusterCount = doClusterCount(state, bestConf);
            do {
                kmAlg.computeClusterCenters(state);
                dif = kmAlg.computeMemberships(state);
            } while (dif > 0);
        }
        while (clusterCount > maxClusterCount) {
            Object bestConf = testRemoveCluster(state, true);
            clusterCount = doClusterCount(state, bestConf);
            do {
                kmAlg.computeClusterCenters(state);
                dif = kmAlg.computeMemberships(state);
            } while (dif > 0);
        }
        return state;
    }

    public int getStream(KMeansState state, double value, double limit) {
        double sum = 0f;
        for (int i = 0; i < state.dataCount; i++) {
            if (state.clusterSquaredDist[i][state.cluster[i]] > limit) {
                sum += state.clusterSquaredDist[i][state.cluster[i]];
                if (sum >= value) {
                    return i;
                }
            }
        }
        return -1;

    }

    public void copyMeans(Object[] means1, Object[] means2, int len) {
        for (int i = 0; i < len; i++) {
            means2[i] = kmAlg.getCopyFunction().invoke(means1[i], means2[i]);
        }
    }

    public Object testAddCluster(KMeansState state, Object bestConf) {

        double bestValidity;
        int best;
        if (bestConf != null) {
            best = ((Number) ((Object[]) bestConf)[0]).intValue();
            bestValidity = ((Number) ((Object[]) bestConf)[1]).doubleValue();
        } else {
            best = 0;
            bestValidity = Double.MAX_VALUE;
        }
        double allSum = 0d;

        for (int i = 0; i < state.dataCount; i++) {
            allSum += state.clusterSquaredDist[i][state.cluster[i]];
        }

        double sum = allSum / state.dataCount;
        double limit = sum;

        Object[] kmeansP = new Object[state.dataCount + 1];
        double[] clusterCountsP = new double[state.dataCount + 1];
        int[] clusterP = new int[state.dataCount + 1];
        double[][] clusterDistP = new double[state.dataCount + 1][state.clusterCount + 1];

        allSum = 0f;
        for (int i = 0; i < state.dataCount; i++) {
            double res = state.clusterSquaredDist[i][state.cluster[i]];
            if (res > limit)
                allSum += res;
        }
        for (int i = 0; i < testCount; i++) {
            testInd[i] = getStream(state, (double) Math.random() * allSum,
                    limit);
        }

        double objective = Double.MAX_VALUE;
        double bestObjective = Double.MAX_VALUE;
        double bestV = Double.MAX_VALUE;
        double validity;
        int bestInd = -1;

        for (int i = 0; i < testCount; i++) {
            if (state.clusterCount == state.maxClusterCount)
                break;
            int ind = testInd[i];
            if (ind >= 0) {
                copyMeans(state.kMeans, kmeansP, state.clusterCount);
                kmeansP[state.clusterCount] = kmAlg.getCopyFunction().invoke(
                        state.data[ind], kmeansP[state.clusterCount]);
                KMeansState stateP = new KMeansState(state.data,
                        state.dataCount, state.clusterCount + 1);
                stateP.clusterSquaredDist = clusterDistP;
                stateP.clusterCounts = clusterCountsP;
                stateP.cluster = clusterP;
                stateP.maxClusterCount = state.maxClusterCount;
                stateP.minClusterCount = state.minClusterCount;
                stateP.kmc = kmAlg;
                stateP.kMeans = kmeansP;
                kmAlg.computeMemberships(stateP);
                kmAlg.computeClusterCenters(stateP);
                kmAlg.computeMemberships(stateP);
                kmAlg.computeClusterCenters(stateP);
                kmAlg.computeMemberships(stateP);
                objective = kmAlg.computeObjective(stateP);
                validity = kmAlg.computeValidity(stateP);
                if (mode == OBJECTIVE_CHOOSE) {
                    if (bestObjective > objective) {
                        bestObjective = objective;
                        bestInd = i;
                        bestV = validity;
                    }
                } else if (mode == VALIDITY_CHOOSE) {
                    if (bestV > validity) {
                        bestObjective = objective;
                        bestInd = i;
                        bestV = validity;
                    }
                }
            }
        }

        if (bestValidity > bestV) {
            bestValidity = bestV;
            best = bestInd + 1;
        }

        return new Object[] { new Integer(best), new Double(bestValidity) };
    }

    protected void switchElement(Object[] ob, int e1, int e2) {
        Object h = ob[e1];
        ob[e1] = ob[e2];
        ob[e2] = h;
    }

    public Object testRemoveCluster(KMeansState state, Object bestConf) {

        int best;
        double bestValidity;
        if (bestConf != null) {
            best = ((Number) ((Object[]) bestConf)[0]).intValue();
            bestValidity = ((Number) ((Object[]) bestConf)[1]).doubleValue();
        } else {
            best = 0;
            bestValidity = Double.MAX_VALUE;
        }
        Object[] kmeansM = new Object[state.dataCount];
        double[] clusterCountsM = new double[state.dataCount];
        int[] clusterM = new int[state.dataCount];
        double[][] clusterDistM = new double[state.dataCount][state.clusterCount];
        double objective = Double.MAX_VALUE;
        double bestObjective = Double.MAX_VALUE;
        double bestV = Double.MAX_VALUE;
        double validity;
        int bestInd = -1;
        for (int i = 0; i < state.clusterCount; i++) {
            /* if (clusterCounts[i]<supportLimit) */{
                if (state.clusterCounts[i] <= 0) {
                    validity = 0;
                    objective=0;
                } else {
                    copyMeans(state.kMeans, kmeansM, state.clusterCount);
                    switchElement(kmeansM, i, state.clusterCount - 1);
                    KMeansState stateM = new KMeansState(state.data,
                            state.dataCount, state.clusterCount - 1);
                    stateM.clusterSquaredDist = clusterDistM;
                    stateM.clusterCounts = clusterCountsM;
                    stateM.cluster = clusterM;
                    stateM.maxClusterCount = state.maxClusterCount;
                    stateM.minClusterCount = state.minClusterCount;
                    stateM.kmc = kmAlg;
                    stateM.kMeans = kmeansM;
                    kmAlg.computeMemberships(stateM);
                    kmAlg.computeClusterCenters(stateM);
                    kmAlg.computeMemberships(stateM);
                    objective = kmAlg.computeObjective(stateM);
                    validity = kmAlg.computeValidity(stateM);
                }
                if (mode == OBJECTIVE_CHOOSE) {
                    if (bestObjective > objective) {
                        bestObjective = objective;
                        bestInd = i;
                        bestV = validity;
                    }
                } else if (mode == VALIDITY_CHOOSE) {
                    if (bestV > validity) {
                        bestObjective = objective;
                        bestInd = i;
                        bestV = validity;
                    }
                }
            }
        }

        if ((bestValidity > bestV) && (state.clusterCount > 2)) {
            bestValidity = bestV;
            best = -(bestInd + 1);
        }

        return new Object[] { new Integer(best), new Double(bestValidity) };
    }

    protected void addCluster(KMeansState state, int nr) {
        state.kMeans[state.clusterCount] = kmAlg.getCopyFunction().invoke(
                state.data[nr], state.kMeans[state.clusterCount]);
        state.clusterCount++;
        kmAlg.computeMemberships(state);
        if (!QUIET)
            System.out.println("ADD:" + nr + "    ClusterCount:"
                    + (state.clusterCount + 1));
    }

    protected void removeCluster(KMeansState state, int nr) {
        switchElement(state.kMeans, nr, state.clusterCount - 1);
        state.clusterCount--;
        kmAlg.computeMemberships(state);
        if (!QUIET)
            System.out.println("REMOVE:" + nr + "    ClusterCount:"
                    + (state.clusterCount - 1));
    }

    public int doClusterCount(KMeansState state, Object bestConf) {
        int best;
        if (bestConf != null) {
            best = ((Number) ((Object[]) bestConf)[0]).intValue();
        } else {
            best = 0;
        }
        if (best > 0) {
            addCluster(state, best - 1);
        } else if (best < 0) {
            removeCluster(state, (-best) - 1);
        } else
            return state.clusterCount;
        kmAlg.computeClusterCenters(state);
        kmAlg.computeMemberships(state);
        return state.clusterCount;
    }

    public int testClusterCount(KMeansState state) {

        double bestValidity = state.kmc.computeValidity(state);
        // System.out.println("minDist: "+fkmAlg.mind+" midDist: "+fkmAlg.sumd);
        Object bestConf = new Object[] { new Integer(0),
                new Double(bestValidity) };
        double min = computeMinimalClusterDist(state.kMeans, state.clusterCount);
        if (min == 0) {
            System.out.println(" min==0!!!!");
            bestConf = new Object[] { new Integer(0),
                    new Double(Double.MAX_VALUE) };
        }
        if (state.clusterCount > state.minClusterCount || min == 0)
            bestConf = testRemoveCluster(state, bestConf);

        if (min > 0 || state.clusterCount <= 2)
            bestConf = testAddCluster(state, bestConf);
        doClusterCount(state, bestConf);
        return state.clusterCount;
    }

    public double computeMinimalClusterDist(Object[] kmeans, int clusterCount) {
        double min = Double.POSITIVE_INFINITY;
        Distance dist = kmAlg.getDistance();
        for (int c = 0; c < clusterCount - 1; c++) {
            for (int c2 = c + 1; c2 < clusterCount; c2++) {
                double distc = dist.distance(kmeans[c], kmeans[c2]);
                if (distc < min) {
                    min = distc;
                }
            }
        }
        return min;
    }

    public int testAddClusterCount(KMeansState state, boolean force) {
        Object bestConf = null;
        if (!force) {
            double bestSeperation = kmAlg.computeValidity(null);
            bestConf = new Object[] { new Integer(0),
                    new Double(bestSeperation) };
        } else {
            bestConf = new Object[] { new Integer(0),
                    new Double(Double.MAX_VALUE) };
        }
        bestConf = testAddCluster(state, bestConf);
        doClusterCount(state, bestConf);
        return state.clusterCount;
    }

    public int testRemoveClusterCount(KMeansState state, boolean force) {
        Object bestConf = null;
        if (!force) {
            double bestSeperation = kmAlg.computeValidity(state);
            bestConf = new Object[] { new Integer(0),
                    new Double(bestSeperation) };
        } else {
            bestConf = new Object[] { new Integer(0),
                    new Double(Double.MAX_VALUE) };
        }
        bestConf = testRemoveCluster(state, bestConf);
        doClusterCount(state, bestConf);
        return state.clusterCount;
    }

    public KMeansClustering getKMeansClustering() {
        return kmAlg;
    }

}
