package pipes;

import xxl.core.pipes.operators.AbstractPipe;
import xxl.core.util.ObjectPool;

public class BlockWeighing extends AbstractPipe<double[][],Object[][]> {
    
    protected int size;
    protected int blockSize;
    protected int blockCount;
    protected double weight;
    protected ObjectPool doublePool;
    protected int windowSize;
    protected Object[][] blockStreams;
    protected Compressor compressor;

    public BlockWeighing(Compressor compressor,int size, int blockSize, int blockCount, double weight, ObjectPool doublePool){
        this.compressor=compressor;
        this.size=size;
        this.blockSize=blockSize;
        this.blockCount=blockCount;
        this.weight=weight;
        this.doublePool=doublePool;
        windowSize = blockSize*blockCount;
        blockStreams=new Object[size][blockSize];
    }

    public void processObject(double[][] data, int ID) throws IllegalArgumentException {
        for(int i=0;i<size;i++){
            System.arraycopy(blockStreams[i],0,blockStreams[i],1,size-1);
            blockStreams[i][0]=compressor.compress(data[i]);
            if (doublePool!=null) doublePool.releaseObject(data[i]);
        }
        transfer(blockStreams);
    }

  

}
