/*
 * Blocker.java
 *
 * Created on 3. Februar 2003, 13:20
 */

package pipes;
import xxl.core.collections.queues.Queue;
import xxl.core.functions.Function;
import xxl.core.util.ObjectPool;
/**
 * Transfer the Blocks of the Elements as double[][] for the StreamCluster-Pipe.
 * To save memory-IO's, the double[][]-Objects will be managed by an ObjectPool. 
 *
 * @author  Jrgen Beringer
 */
public class Blocker extends BlockSynchronizer {
	int size;
	int blockSize;
	
	ObjectPool doublePool;
	/** Creates a new instance of Blocker */
	public Blocker(final int size,final int blockSize) {
		super(size,blockSize);
		this.blockSize=blockSize;
		this.size=size;
		
		doublePool=new ObjectPool(new Function(){
			public Object invoke(){
				return new double[blockSize];
			}
		},
		size*10);
	}
	
		
	public ObjectPool getFloatPool(){
		return doublePool;
	}
	
	public void processQueues(Queue[] queues) {
		//System.out.print("Output!");
		double[][] newBlocks=new double[size][];
		for (int i=0;i<size;i++){
			double[] newObjects=(double[])doublePool.getObject();
			newBlocks[i]=newObjects;
			for (int j=0;j<blockSize;j++){
				try{
					newObjects[j]=((Number)queues[i].dequeue()).doubleValue();
				}catch(Exception e){
					e.printStackTrace();
				}
			}
		}
		transfer(newBlocks);
		/*for (int i=0;i<size;i++){
			doublePool.releaseObject(newBlocks[i]);
		}*/
	}


}
