/*
 * Created on 18.03.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import xxl.core.pipes.sinks.AbstractSink;

/**
 * @author beringer
 */
public class ClusterWriter extends AbstractSink {

	protected int count;

	protected int clusterCount;

	protected Object[] streamsObjects;

	protected double[][] values;

	protected boolean disposed = false;

	protected Writer writer;

	static boolean DEBUG = false;

	public ClusterWriter(Object[] streamsObjects, int clusterCount, String file)
			throws IOException {
		this(streamsObjects, clusterCount, new FileWriter(file));
	}

	public ClusterWriter(Object[] streamsObjects, int clusterCount,
			Writer writer) {
		this.streamsObjects = streamsObjects;
		count = streamsObjects.length;
		this.clusterCount = clusterCount;
		this.writer = writer;
		try {
			for (int i = 0; i < count; i++) {
				writer.write(streamsObjects[i].toString());
				if (i + 1 < count) writer.write('\t');
			}
			writer.write('\n');
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public void processObject(Object ob, int id) {
		if (DEBUG) System.out.println("Input");
		if (disposed) { return; }
		int[] aktValues = (int[]) ob;
		try {
			for (int i = 0; i < count; i++) {
				writer.write(""+aktValues[i]);
				if (i + 1 < count) writer.write('\t');
			}
			writer.write('\n');
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public void done(int ID) {
		disposed = true;
		try {
			writer.flush();
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}