package pipes;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;

import xxl.core.util.CompositeMetaData;

public class ClusteringLoader extends MultiplePipe {

    static protected int[] IDs = new int[] { 0, 1, 2 };

    protected ObjectInputStream din;

    protected boolean complex;

    double[][] cluster;

    int kValue;
    
    int initCount;
    
    int init;

    Object[] kMeans;

    public ClusteringLoader(ObjectInputStream din, boolean complex, int initCount) {
        super(IDs);
        this.din = din;
        this.complex = complex;
        this.initCount=initCount;
        init=0;
    }

    public ClusteringLoader(String file, boolean complex, int initCount) {
        super(IDs);
        try {
            din = new ObjectInputStream(new BufferedInputStream(
                    new FileInputStream(file)));
            this.complex = complex;
            this.initCount=initCount;
            init=0;
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void processObject(Object o, int ID) throws IllegalArgumentException {
        if (init<initCount) {
            init++;
            if (init<initCount) return;
        }
        
        cluster = (double[][]) readRat();
        if (complex)
            kMeans = readComplex();
        else
            kMeans = readRat();
        kValue = kMeans.length;

        transfer(cluster, IDs[0]);
        transfer(kValue, IDs[1]);
        transfer(kMeans, IDs[2]);
    }

    protected double[][][] readComplex() {
        try {
            int size1 = din.readInt();
            int size2 = din.readInt();
            double[][][] complex = new double[size1][size2][2];
            for (int i = 0; i < size1; i++) {
                for (int j = 0; j < size2; j++) {
                    complex[i][j][0] = din.readDouble();
                    complex[i][j][1] = din.readDouble();
                }
            }
            return complex;
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return null;
    }

    protected double[][] readRat() {
        try {
            int size1 = din.readInt();
            int size2 = din.readInt();
            double[][] complex = new double[size1][size2];
            for (int i = 0; i < size1; i++) {
                for (int j = 0; j < size2; j++) {
                    complex[i][j] = din.readDouble();
                }
            }
            return complex;
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return null;
    }

    public CompositeMetaData getMetaData() {
        // TODO Auto-generated method stub
        return null;
    }

}
