package pipes;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import xxl.core.pipes.operators.AbstractPipe;
import clustering.Distance;
import clustering.FuzzyKMeansState;

public class CompareFuzzyClustering2 extends AbstractPipe {
    
    protected Writer out;
    
    protected FuzzyKMeansState state;
    protected FuzzyKMeansState state2;
    protected Object[] data;
    protected int dataCount;
    protected boolean complex;
    protected double[][]values1;
    protected Distance distance1;
    protected boolean set1=false;
    protected boolean set2=false;
    
    protected boolean end=false;
    protected int count=0;
    
    protected CompareFuzzyClustering2(int dataCount, boolean complex, Distance distance){
        this.dataCount=dataCount;
        this.complex=complex;
        distance1=distance;
    }
    
    public CompareFuzzyClustering2(Writer out,int dataCount, boolean complex, Distance distance){
        this(dataCount,complex,distance);
        this.out=out;
    }
    
    public CompareFuzzyClustering2(String fileout,int dataCount, boolean complex, Distance distance){
        this(dataCount,complex,distance);
        try {
            out=new BufferedWriter(new FileWriter(fileout));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    

    @Override
    public void processObject(Object o, int ID) throws IllegalArgumentException {
        if (ID==0){
            state=(FuzzyKMeansState)o;
            data=state.data;
            set1=true;
        }else if (ID==1){
            state2=(FuzzyKMeansState)o;
            set2=true;
        }
        if (set1 && set2){
            set1=false;
            set2=false;
            compareNext();
        }
        
        count++;
        if (count == 204){
            try {
                out.write('\n');
                out.flush();
                out.close();
                end=true;
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    }

    protected void compareNext() {
        double val1=CompareFuzzyClustering.compare(state.fuzzyCluster,state.clusterCount,state.kMeans,state2.fuzzyCluster,state2.clusterCount,state2.kMeans,dataCount,distance1);
        
        try {
            out.write(val1+"  ");
            out.flush();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
    }
    
   
    
    protected double distance(Object[] data1, Object[] data2, int dataCount, Distance distance){
        double res=0;
        for (int i=0;i<dataCount;i++){
            res+=distance.distance(data1[i],data2[i]);
        }
        return res;
    }
    
    
    
    public void close(){
        try {
            out.flush();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        super.close();
    }

}
