/*
 * Created on 14.05.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes;

import xxl.core.pipes.operators.AbstractPipe;

/**
 * @author beringer
 */
public class DFTStream extends AbstractPipe<double[][],double[][][]> {
	
	double[][][] dftValues;
	double[][] helpDFT;
	int windowSize;
	int dftCount;
	int size;
	
	public DFTStream(int windowSize, int dftCount, int size){
		this.windowSize=windowSize;
		this.dftCount=dftCount;
		this.size=size;
		dftValues=new double[size][dftCount][2];
		helpDFT=new double[windowSize][2];
	}
	
	public void processObject(double[][] obs, int ID){
		for (int i=0;i<size;i++){
			double[] values=obs[i];
			for (int j=0;j<windowSize;j++){
				helpDFT[j][0]=values[j];
				helpDFT[j][1]=0.0;
			}
			fft(helpDFT);
			for (int j=0;j<dftCount;j++){
				dftValues[i][j][0]=helpDFT[j+1][0];
				dftValues[i][j][1]=helpDFT[j+1][1];
			}
		}
		transfer(dftValues);
		
	}

	static double PI=Math.PI;
	
	static public void fft(double[][] values){
		fftMain(values);
		int n=values.length;
		double sq=Math.sqrt(n);
		for (int i=0;i<n;i++){
			values[i][0]/=sq;
			values[i][1]/=sq;
		}
	}
	
	
	static public void fftMain(double[][] values){
		int n=values.length;
		int nd2=(n>>1);
		int n2,n3;
		int pos2=0;
		double swap0,swap1;
		int k;
		
		
		for (int i=0;i<n;i++){
			n2=nd2;n3=1;k=0;
			while (n2>=n3){
				if ((i&n2) >0) k=k|n3;
				if ((i&n3) >0) k=k|n2;
				n2=n2>>1;
				n3=n3<<1;
			}
			//System.out.println(k);
			if (i<k){
				//System.out.println("swap :"+i+","+k);
				swap0=values[i][0];
				swap1=values[i][1];
				values[i][0]=values[k][0];
				values[i][1]=values[k][1];
				values[k][0]=swap0;
				values[k][1]=swap1;
			}
		}
		
		int dist=1;
		for (int pot2=2;pot2<=n;pot2<<=1,dist<<=1){
			double u0 = 1.0;
			double u1 = 0.0;
			double w0 =  Math.cos( Math.PI / (double)dist );
			double w1 = -Math.sin( Math.PI / (double)dist );
			for(int j=0;j<dist;j++) {
				for(int i=j;i<n;i+=pot2) {
					pos2=i+dist;
					//System.out.println("pos:"+(i)+" pos2:"+(pos2)+"    "+u0+","+u1);
					double val0=values[pos2][0] * u0 - u1 * values[pos2][1];
					double val1=values[pos2][1] * u0 + u1 * values[pos2][0];
					values[pos2][0] = values[i][0] - val0;
					values[pos2][1] = values[i][1] - val1;
					values[i][0] =  values[i][0] + val0;
					values[i][1] =  values[i][1] + val1;
				}
				double h=u0*w0-w1*u1;
				u1=w0*u1+w1*u0;
				u0=h;
			}
		}
	}
}
