package pipes;

import xxl.core.functions.Function;
import xxl.core.pipes.sinks.AbstractSink;

public class FunctionStream<E> extends AbstractSink<E> {

    protected int start = -1;

    protected int stop = -1;

    protected Function<E, Object> func;

    protected int step = 0;

    public FunctionStream() {
    }

    /**
     * Set number of stored stream elements. For infinity storage, use -1.
     * 
     * @param max
     *            number of storing elements
     */
    public void setStartStop(int start, int stop) {
        this.start = start;
        this.stop = stop;
    }

    public void setFunction(Function func) {
        this.func = func;
    }

    
    public void processObject(E o, int ID) throws IllegalArgumentException {
        step++;
        if (start < 0 || step >= start) {
            if (stop < 0 || step <= stop) {
                if (func != null)
                    func.invoke(o);
                
            }else
                this.stop();
        }
    }

}
