/*
 * StreamCluster.java
 *
 * Created on 3. Februar 2003, 11:17
 */


package pipes;
import utils.math.DFT;
import xxl.core.pipes.operators.AbstractPipe;

/**
 *
 * @author  Jrgen Beringer
 */
public class IDFTStreams extends AbstractPipe<Object[],double[][]>{
	
		
	static boolean DEBUG=false;
	
	//Anzahl von Streams
	int size;
	//Grsse des Gesamten Fensters
	int windowSize;
	//Wurzel der Fenstergrsse (oft bentigt)
	double sqrtWS;
	
	//DFT-Werte der Streams
	double[][] dfts;
	double[] mid;
	//hilfsvariablen
	double[][] values1;
	
	int dftCount;
	
	double faktor;
	
	double[][] output;
	//Beschriftung(Namen) der Streams
	Object[] streamsObjects;
	
	
	public IDFTStreams(Object[] streamsObjects, int size, int windowSize, int dftCount) {
		this(streamsObjects,size,windowSize,dftCount,1f);
	}
	
	/** Creates a new instance of StreamCluster */
	public IDFTStreams(Object[] streamsObjects, int size, int windowSize, int dftCount, double faktor) {
		this.streamsObjects=streamsObjects;
		this.size=size;
		this.dftCount=dftCount;
		this.windowSize=windowSize;
		this.faktor=faktor;
		sqrtWS=(double)Math.sqrt(windowSize);
		//dftweights2=new double[windowSize][2];
		output=new double[size][windowSize];
		
		values1=new double[windowSize][2];
	}
	
	
	public void processObject(Object[] input,int id){
		int aktSize=input.length;
		for (int i=0;i<aktSize;i++){
			dfts=(double[][])input[i];
			for (int m=dftCount+1;m<windowSize-dftCount;m++){
				values1[m][0]=0;
				values1[m][1]=0;
			}
			for (int m=1;m<=dftCount;m++){
				values1[m][0]=dfts[m-1][0];
				values1[m][1]=dfts[m-1][1];
				values1[windowSize-m][0]=dfts[m-1][0];
				values1[windowSize-m][1]=-dfts[m-1][1];
			}
			values1[0][0]=0;
			values1[0][1]=0;
			
			DFT.fft(values1);
			
			for (int m=1;m<windowSize;m++){
				double val=Math.sqrt(values1[windowSize-m][0]*values1[windowSize-m][0]+values1[windowSize-m][1]*values1[windowSize-m][1]);
				if (values1[windowSize-m][0]<0.0) val=-val;
				//val+=mid[i];
				output[i][m]=(double)val*faktor;
			}
            output[i][0]=values1[0][0];
		}
		
		
		transfer(output);

	}
	
		
}

