package pipes;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

import applications.pipes.SimpleStreaming;

public class LoadStreams extends MultipleSource {
    
    static protected int[] ID;
    
    static{
        ID=new int[1000];
        for(int i=0;i<1000;i++)
            ID[i]=i;
    }

    protected BufferedReader read;

    protected int blocksize;

    protected int datacount;

    protected String name;

    protected String[] obs;

    protected double[][] next;

    public LoadStreams(String file, int blocksize, int period)
            throws FileNotFoundException {
        this(new FileReader(file), blocksize, period);
    }

    public LoadStreams(Reader read, int blocksize, int period) {
        super(ID,period);
        //processor.setPriority(Thread.NORM_PRIORITY-1);
        if (read instanceof BufferedReader)
            this.read = (BufferedReader) read;
        else
            this.read = new BufferedReader(read);
        this.blocksize = blocksize;
        openStream();
        this.closeMode=NEXT_CLOSE;
    }

    public void openStream() {
        try {
            String line = null;
            do {

                line = read.readLine().toLowerCase();

            } while (!line.startsWith("@relation"));
            line = line.substring(9);
            while (line.startsWith(" ") || line.startsWith("'")
                    || line.startsWith("\"") || line.startsWith("(")) {
                line = line.substring(1);
            }
            while (line.endsWith(" ") || line.endsWith("'")
                    || line.endsWith("\"") || line.endsWith(")")) {
                line = line.substring(0, line.length() - 1);
            }
            name = line;
            List<String> atts = new ArrayList();
            do {

                do {
                    line = read.readLine();
                } while (!line.startsWith("@"));
                if (line.toLowerCase().startsWith("@attribute")) {
                    String att = line.substring(10);
                    while (att.startsWith(" ") || att.startsWith("'")
                            || att.startsWith("\"") || att.startsWith("(")) {
                        att = att.substring(1);
                    }
                    if (att.indexOf('\'')>=0) att = att.substring(0, att.indexOf('\''));
                    else if (att.indexOf('"')>=0) att = att.substring(0, att.indexOf('"'));
                    else att = att.substring(0, att.lastIndexOf(' '));
                    while (att.endsWith(" ") || att.endsWith("'")
                            || att.endsWith("\"") || att.endsWith(")")) {
                        att = att.substring(0, att.length() - 1);
                    }
                    atts.add(att);
                }
            } while (line.toLowerCase().startsWith("@attribute"));
            datacount = atts.size();
            obs = new String[datacount];
            obs = atts.toArray(obs);
            while (!line.toLowerCase().startsWith("@data")) {
                line = read.readLine();
            }
            next=read();

        } catch (IOException e) {
            e.printStackTrace();
            next=null;
        }
    }

    public double[][] read() throws NoSuchElementException {
        double[][] data = new double[datacount][blocksize];

        for (int i = 0; i < blocksize; i++) {
            String line = "";
            try {
                line = read.readLine();
            } catch (IOException e) {
                try {
                    read.close();
                } catch (IOException e1) {
                    throw new NoSuchElementException();
                }
                throw new NoSuchElementException();
            }
            if (line==null) throw new NoSuchElementException();
            StringTokenizer toks = new StringTokenizer(line, " ,;:^t");
            if (toks.countTokens() < datacount) {
                try {
                    read.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                return data;
            }
            for (int j = 0; j < datacount; j++) {
                data[j][i] = Double.parseDouble(toks.nextToken());
            }
        }
        return data;
    }

    public Object next() throws NoSuchElementException {
        if (next == null) {
            SimpleStreaming.rerun();
            //System.exit(0);
            this.close();
            throw new NoSuchElementException();
        }
        Object ret = next;
        try {
            next = read();
        } catch (NoSuchElementException e1) {
            next = null;
        }
        return ret;
    }

}
