/*
 * MultiSource.java
 *
 * Created on 27. Januar 2003, 11:47
 */

package pipes;
import java.sql.ResultSetMetaData;
import java.util.Iterator;
import java.util.NoSuchElementException;

import xxl.core.cursors.AbstractCursor;
import xxl.core.cursors.sources.Repeater;
import xxl.core.functions.Function;
import xxl.core.pipes.sources.AbstractSource;
import xxl.core.relational.cursors.InputStreamMetaDataCursor;
import xxl.core.relational.metaData.ResultSetMetaDatas;
import xxl.core.relational.tuples.Tuple;
/**
 *
 * @author  Jrgen Beringer
 */
public class MultiSource extends MultipleSource {
	protected int windowsize;
	protected int period;
	protected Function nextFactory;
	protected boolean begin= true;
	protected Object[] list;
	protected int number;
	/** Creates a new instance of MultiSource */
	public MultiSource(Function nextFactory, int count, int period, int windowsize) {
		super(count,period);
        ((Repeater)this.processor.getDelayManager()).update(new Long(period));
		this.processor.setPriority(Thread.MAX_PRIORITY);
		this.count= count;
		this.period= period;
		this.windowsize= windowsize;
		this.nextFactory= nextFactory;
		number= 0;
	}

	public Object next() throws NoSuchElementException {
//		if (begin && (number >= windowsize)) {
//			begin= false;
//			((Repeater)this.processor.getDelayManager()).update(new Long(period));
//			this.processor.setPriority(Thread.MAX_PRIORITY);
//			System.out.println("!!!!  SET  PERIOD  !!!");
//		}
		//if (begin)
			number++;
		list= (Object[]) nextFactory.invoke();
		
		/*for(int i=0;i<count;i++){
			try{
				obs[i]=list[i];
			}catch(Exception e){e.printStackTrace();}
		}*/
		return list;
	}

//	public synchronized int transfer(Object o) {
//        if (o==null) return 0;
//		Object[] obs= (Object[]) o;
//		int counter= 0;
//		if (sinks != null) {
//			for (int i= 0;(sinks != null) && (i < sinks.length); i++) {
//				//System.out.println(sinks[i]);
//				if (bitSet.get(i)) {
//					sinks[i].process(obs[sinkIDs[i]], sinkIDs[i]);
//					counter++;
//				}
//			}
//		}
////		if (number==windowsize)
////			System.out.print("");
//		
//		return counter;
//	}

	public int getCount() {
		return count;
	}

	public static Function getFactory(final int co, final int windowsize) {
		final double[] periods= new double[co];
		for (int i= 0; i < co; i++) {
			periods[i]= (double) ((Math.random() * 10) - 5);
			//periods[i]=(i%5)+1;
			//periods[i]=2;
			//periods[i]=(int)((Math.random()*5)+1);
		}
		return new Function() {
			int nr= 128;
			public Object invoke() {
				nr++;
				Object[] list= new Object[co];
				for (int i= 0; i < co; i++) {
					list[i]=
						new Float((double) Math.sin(2 * Math.PI * nr * periods[i] / windowsize));
				}
				return list;
			}
		};
	}

	public static Function getTestFactory(final int co, final int windowsize) {
		final double[] periods= new double[co];
		final int ind= 3;
		final int ind2= 3;
		final double per= 6.0f;
		final int change= windowsize * 2;
		periods[0]= per;
		periods[1]= -per;
		periods[2]= 2f;
		periods[3]= per;
		periods[4]= per;
		periods[5]= -per;
		periods[6]= 2f;
		//periods[7] = per;
		/*periods[3]=-per;
		periods[4]=per;*/
		/*periods[5]=-1f;
		periods[6]=1f;*/

		return new Function() {
			int nr= 0;
			public Object invoke() {
				nr++;
				//if (nr %16==0) System.out.print("Ich schlaf net!");
				if (nr % change == 0) {
					periods[ind]= per;
					periods[ind2]= per;
					System.out.println("!!!!!!!!!!! ch 0 !!!!!!!!!");
				}
				if (nr % change == (change >> 1)) {
					periods[ind]= -per;
					periods[ind2]= -per;
					System.out.println("!!!!!!!!!!! ch 1 !!!!!!!!!");
				}

				Object[] list= new Object[co];
				for (int i= 0; i < co; i++) {
					list[i]=
						new Float(
							(double) (0.8
								* Math.sin(2 * Math.PI * nr * periods[i] / windowsize)
								/ 0.7063178)
								+ Math.random() * 0.8
								- 0.4);
					//(nr%4<2)?new Float(1f*periods[i]):new Float(-1f*periods[i]);
				}
				return list;
			}
		};
	}

	public static Function getTest2Factory(
		final int co,
		final int cluster,
		final int diff,
		final int windowsize) {
		final double[] periods= new double[co];
		final Object[] list= new Object[co];
		for (int i= 0; i < co; i++) {
			periods[i]= (double) ((2 * ((int) (Math.random() * cluster) - (cluster / 2)) + 1));
			System.out.println("Period " + periods[i]);
		}
		for (int i= 0; i < cluster; i++) {
			periods[i]= 2 * ((int) (i) - (cluster / 2)) + 1;
		}

		return new Function() {
			int nr= 0;
			public Object invoke() {
				nr++;
				//if (nr %16==0) System.out.print("Ich schlaf net!");
				/*if (nr %2048==0){
					for (int i=0;i<co;i++){
						System.out.println("Period "+periods[i]);
					}
				}*/
				for (int i= 0; i < co; i++) {
					if (Math.random() < 0.00009) {

						System.out.println("!!! CHANGE !!!!  " + i);
						periods[i]=
							(double) ((2 * ((int) (Math.random() * diff) - (diff / 2)) + 1));
						;
						if (i == 0)
							periods[i]= 21;
					}
				}

				//Object[] list = new Object[co];
				for (int i= 0; i < co; i++) {
					list[i]=
						new Double(
							(double) (0.6 * Math.sin(2 * Math.PI * nr * periods[i] / windowsize))
								+ Math.random() * 0.8
								- 0.4);
				}
				return list;
			}
		};
	}

	public static Function getCursorFactory(final java.util.Iterator it) {
		return new Function() {
			public Object invoke() {
				return it.next();
			}
		};
	}

	public static Object[] getStreamNames(
		final InputStreamMetaDataCursor fmdc,
		final int count,
		final int offset) {
		Object[] obs= new Object[count];
		ResultSetMetaData rsmd= ResultSetMetaDatas.getResultSetMetaData(fmdc);
		try {
			for (int i= 0; i < count; i++) {
				obs[i]= i+". "+rsmd.getColumnName(i + offset);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obs;
	}
	
	public static Iterator getMultiSourceFileIterator(
			final AbstractCursor fmdc,
			final int count,
			final int offset){
		return getMultiSourceFileIterator(fmdc,count,offset,null);
	}

	public static Iterator getMultiSourceFileIterator(
		final AbstractCursor fmdc,
		final int count,
		final int offset,
		final Function rerun) {

        return new AbstractCursor() {
            public Object nextObject() {
                if (!fmdc.hasNext()) {
                    System.out.println(
                        "\n\n\n\n\n\n\n\n\n!!!!!!!!!  E N D E !!!!!!!!!!!!\n\n\n\n\n\n\n\n\n");
                    return null;
                }
                Tuple tup = (Tuple)fmdc.next();
                Object[] obs = new Object[count];
                for (int i = 0; i < count; i++) {
                    obs[i] = tup.getObject(i + offset);
                }
                return obs;
            }
            public boolean hasNextObject(){
                if (!fmdc.hasNext()) {
                    System.out.println(
                        "\n\n\n\n\n\n\n\n\n!!!!!!!!!  E N D E !!!!!!!!!!!!\n\n\n\n\n\n\n\n\n");
                    return false;
                }
                else return true;
            }
        };
	}

	public static Function getFunctionalFactory(
		final int count,
		final Function[] func,
		final Function[] add,
		final Function[] distort) {

		return new Function() {
			int nr= 0;
			public Object invoke() {
				nr++;
				Object[] list= new Object[count];
				for (int i= 0; i < count; i++) {
					list[i]=
						new Float(
							((Number) func[i]
								.invoke(
									new Double(
										nr
											+ ((Number) distort[i].invoke(new Integer(nr)))
												.doubleValue())))
								.floatValue()
								* (1 + ((Number) add[i].invoke(new Integer(nr))).floatValue()));

				}
				return list;
			}
		};
	}

	public static Function[] getFunctions(int count, final int windowSize, final int blockSize,final double[] pert,final double[] offt) {
		Function[] func= new Function[count];
		//final double[] pert= new double[] { 2.37, 2.37, 2.37 / 2 };
		//final double[] offt= new double[] { 0.0, 2.17, 3.925 };
		//final double[] pert= new double[] { 3.97, 3.97, 3.97 / 2 };
		//final double[] offt= new double[] { 0.0, 3.14, 0.0 };
		final double[] per= new double[count];
		final double[] off= new double[count];
		final double[] rad= new double[count];
		for (int i= 0; i < count; i++) {
			off[i]= offt[i % 3];
			rad[i]= 0.8;
			per[i]= pert[i % 3];
		}
		for (int i= 0; i < count; i++) {
			final int ind= i;
			func[i]= new Function() {
				public Object invoke(Object ob) {
					return new Float(
						rad[ind]
							* Math.sin(
								off[ind]
									+ 2.0
										* Math.PI
										* per[ind]
										* ((Number) ob).doubleValue()
										/ windowSize));
				}
			};
		}
		func[3]= new Function() {
			long last= 0;
			int ind= 0;
			double peris= per[3];
			double offs= off[3];
			
			public Object invoke(Object ob) {

				if (((Number) ob).doubleValue() - last >= (windowSize + 2 * blockSize)) {
					last += (windowSize + 2 * blockSize);
					if (ind == 0)
						ind= 1;
					else
						ind= 0;
					peris= per[ind];
					offs= off[ind];
					System.out.println("CHANGE");
				}
				return new Float(
					rad[3]
						* Math.sin(
							offs
								+ 2.0 * Math.PI * peris * ((Number) ob).doubleValue() / windowSize));
			}
		};
		return func;
	}

	public static Function[] getEpsFunctions(
		int count,
		final int windowSize,
		double epsmin,
		double epsmax,
		double fmin,
		double fmax) {
		Function[] func= new Function[count];
		for (int i= 0; i < count; i++) {
			final double eps= Math.random() * (epsmax - epsmin) + epsmin;
			final double per= Math.random() * (fmax - fmin) + fmin;
			func[i]= new Function() {
				public Object invoke(Object ob) {
					return new Float(
						eps
							* Math.sin(
								2.0 * Math.PI * per * ((Number) ob).doubleValue() / windowSize));
				}
			};
		}
		return func;
	}

}
