package pipes;

import java.io.IOException;

import xxl.core.functions.Function;
import xxl.core.pipes.sinks.AbstractSink;

public class NullSink extends AbstractSink {

    protected int step = 0;

    protected int max = -1;

    protected Function func;

    public void setMaxCount(int max) {
        this.max = max;
    }

    public void setFunction(Function func) {
        this.func = func;
    }

    public void processObject(Object o, int ID) throws IllegalArgumentException {
        step++;
        if (max > 0 && step > max) {
            stop();
            return;
        }

        if (max > 0 && step >= max) {
            if (func != null) {
                func.invoke();
                stop();
            } else {
                stop();
                System.exit(0);
            }

        }
    }

}
