package pipes;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import xxl.core.pipes.sinks.AbstractSink;

public class SaveRealStreamsARFF extends AbstractSink<Object[]> {

    protected int datacount;

    protected Writer write;

    protected int step = 0;

    public SaveRealStreamsARFF(String file, String name, int datacount, String[] streams)
            throws IOException {
        this(new BufferedWriter(new FileWriter(file)), name, datacount, streams);
    }

    public SaveRealStreamsARFF(Writer write, String name, int datacount,
            String[] streams) {
        this.datacount = datacount;
        this.write = write;
        try {
            write.write("@relation " + name + "\n\n");
            for (int i = 0; i < datacount; i++) {
                write.write("@attribute '" + streams[i] + "' real\n");
            }
            write.write("\n\n@data\n");
            write.flush();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    @Override
    public void processObject(Object[] o, int ID)
            throws IllegalArgumentException {
        step++;
        System.out.println("Step: " + step);
        double[] vals = (double[]) o[0];
        int len = vals.length;
        try {
            for (int j = 0; j < len; j++) {
                for (int i = 0; i < datacount; i++) {
                    write.write("" + ((double[]) o[i])[j]);
                    if (i + 1 < datacount)
                        write.write(", ");
                    else
                        write.write("\n");
                }
            }
            write.flush();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        if (step == 220)
            System.exit(0);
    }

    public void close() {
        try {
            write.flush();
            write.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

}
