package pipes.classifier;

import java.util.NoSuchElementException;

import weka.datagenerators.AdaptiveGenerator;
import xxl.core.cursors.sources.Repeater;
import xxl.core.pipes.sources.AbstractSource;
import xxl.core.util.CompositeMetaData;

public class GeneratorSource extends AbstractSource {

    protected AdaptiveGenerator gen;

    protected boolean init;

    protected int time;
    
    protected CompositeMetaData meta=null;
    
    protected long period;

    public GeneratorSource(AdaptiveGenerator gen, int initsize, long initPeriod, long period) {
        super(period);
        this.gen=gen;
        time = -initsize;
        this.period=period;
    }

    public Object next() throws NoSuchElementException {
        time++;
        if (time==0){
            ((Repeater)this.processor.getDelayManager()).update(new Long(period));
        }
        return gen.generateExample(time);
    }
    
    public int getTime(){
        return time;
    }

    public CompositeMetaData getMetaData() {
        if (meta==null){
            meta=new CompositeMetaData();
            meta.put("header",gen.defineDataFormat());
        }
        meta.put("time",new Integer(time));
        return meta;
    }
    
    public void pauseUntilWakeUp(){
        if (!isClosed) processor.hasToPauseUntilWakeUp();
    }
    
    public void wakeUp(){
        if (!isOpened) open();
        processor.wakeUp();
    }

}
