package pipes.classifier;

import weka.classifiers.Classifier;
import weka.core.Instance;
import weka.core.Instances;
import weka.datagenerators.AdaptiveGenerator;
import xxl.core.pipes.operators.AbstractPipe;

public class StaticAccuracy extends AbstractPipe {
    
    protected AdaptiveGenerator gen;
    protected int testLength;
    
    public StaticAccuracy(AdaptiveGenerator gen, int testLength){
        this.gen=gen;
        this.testLength=testLength;
    }
    
    
    public void processObject(Object o, int ID) throws IllegalArgumentException {
        Classifier classifier=(Classifier)o;
        Instances ins = gen.getInitData(testLength);
        int correct=0;
        try{
        for (int j = 0; j < testLength; j++) {
            int lab = gen.getLabel(ins.instance(j));

            Instance inst2 = ins.instance(j);
            int cls = (int) classifier.classifyInstance(inst2);
            if (cls == lab)
                correct++;
        }
        }catch(Exception e){
            e.printStackTrace();
        }
        transfer(correct/(double)testLength);
    }

}
