package pipes.classifier;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import utils.visibility.DrawField2D;
import utils.visibility.Drawable;
import utils.visibility.Drawer;
import weka.core.Instance;
import xxl.core.pipes.sinks.AbstractSink;
import xxl.core.util.CompositeMetaData;

public class ViewData extends AbstractSink<Object> implements Drawable {

    static Color[] cols = new Color[] { Color.BLACK, Color.RED, Color.BLUE,
            Color.GREEN, Color.YELLOW, Color.MAGENTA };

    List<Instance> drawData = new ArrayList();
    
    List<Drawer> drawers=new ArrayList();

    public ViewData() {

    }

    public void processObject(Object data, int ID)
            throws IllegalArgumentException {
        // TODO Auto-generated method stub
        drawData = new ArrayList((List<Instance>)data);
        for(Drawer drawer:drawers){
            drawer.updated(this);
        }
    }

    public void draw(DrawField2D draw) {
        Iterator it = drawData.iterator();
        while (it.hasNext()) {
            Instance inst = (Instance) it.next();
            int val = (int) inst.value(3);

            if (val == 0)
                draw.markPoint(inst.value(1), inst.value(2), cols[val], 5,
                        DrawField2D.CROSS);
            else
                draw.markPoint(inst.value(1), inst.value(2), cols[val], 7,
                        DrawField2D.POINT);

        }
    }

    public void addDrawer(Drawer drawer) {
        drawers.add(drawer);
    }

    public void removeDrawer(Drawer drawer) {
        drawers.remove(drawer);
    }

}
