package pipes.classifier;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import utils.visibility.DrawField2D;
import utils.visibility.Drawable;
import utils.visibility.Drawer;
import weka.core.Instance;
import weka.datagenerators.AdaptiveGenerator;
import xxl.core.pipes.sinks.AbstractSink;

public class ViewModel extends AbstractSink<Object> implements Drawable {

    static Color[] cols = new Color[] { Color.BLACK, Color.RED, Color.BLUE,
            Color.GREEN, Color.YELLOW, Color.MAGENTA };

    protected AdaptiveGenerator gen;
    
    List<Drawer> drawers=new ArrayList();

    public ViewModel(AdaptiveGenerator gen) {
        this.gen=gen;
    }

    public void processObject(Object data, int ID)
            throws IllegalArgumentException {
        // TODO Auto-generated method stub
        for(Drawer drawer:drawers){
            drawer.updated(this);
        }
    }

    public void draw(DrawField2D draw) {
        int steps = 50;
        double stepX = (draw.getMaxX() - draw.getMinX()) / steps;
        double stepY = (draw.getMaxY() - draw.getMinY()) / steps;
        double posX = draw.getMinX();
        for (int x = 0; x <= steps; x++) {
            double posY = draw.getMinY();
            for (int y = 0; y <= steps; y++) {
                double[] values = new double[] { 0, posX, posY, 0 };
                Instance inst = new Instance(1.0, values);
                int val = (int) gen.getLabel(inst);
                if (val > 0)
                    draw.markPoint(inst.value(1), inst.value(2), cols[val],
                            3, DrawField2D.POINT);
                posY += stepY;
            }
            posX += stepX;
        }
    }

    public void addDrawer(Drawer drawer) {
        drawers.add(drawer);
    }

    public void removeDrawer(Drawer drawer) {
        drawers.remove(drawer);
    }

}
