package pipes.classifier;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import utils.visibility.DrawField2D;
import utils.visibility.Drawable;
import utils.visibility.Drawer;
import weka.classifiers.rules.rise.SimpleConjunctiveRule;
import xxl.core.pipes.sinks.AbstractSink;

public class ViewRules extends AbstractSink<Object>
        implements Drawable {

    static Color[] cols = new Color[] { Color.BLACK, Color.RED, Color.BLUE,
            Color.GREEN, Color.YELLOW, Color.MAGENTA };

    List<double[]> ruleData = new ArrayList();
    
protected List<Drawer> drawers=new ArrayList();
    
    

    public ViewRules() {

    }

    public void processObject(Object ob, int ID)
            throws IllegalArgumentException {
        // TODO Auto-generated method stub
        ruleData.clear();
        List<SimpleConjunctiveRule> rules=(List<SimpleConjunctiveRule>) ob;
        Iterator it = rules.iterator();
        while (it.hasNext()) {
            SimpleConjunctiveRule rule = (SimpleConjunctiveRule) it.next();
            double[] range1 = rule.getNumericRange(1);
            double[] range2 = rule.getNumericRange(2);
            if (rule.getDistributionSum() > 1)
                ruleData.add(new double[] { range1[0], range1[1], range2[0],
                        range2[1], rule.getClassValue() });
            else
                ruleData.add(new double[] { range1[0], range1[1], range2[0],
                        range2[1], rule.getClassValue() });
        }
        for(Drawer drawer:drawers){
            drawer.updated(this);
        }
    }

    public void draw(DrawField2D draw) {
        Iterator it = ruleData.iterator();
        double difX = 0;
        //(draw.getMaxX() - draw.getMinX())
          //      / (draw.getWidth() >> 1);
        double difY =0;// (draw.getMaxY() - draw.getMinY())
            //    / (draw.getHeight() >> 1);

        while (it.hasNext()) {
            double[] rule = (double[]) it.next();
            draw.drawRect(rule[0] - difX, rule[2] - difY, rule[1] + difX,
                    rule[3] + difY, cols[(int) rule[4]]);
        }
    }
    
    public void addDrawer(Drawer drawer) {
        drawers.add(drawer);
    }

    public void removeDrawer(Drawer drawer) {
        drawers.remove(drawer);
    }

}
