package pipes.classifier;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import xxl.core.functions.Function;
import xxl.core.pipes.sinks.AbstractSink;

public class VisualizeData extends AbstractSink {

    protected int fieldCount;

    protected JTextField[] fields;

    public VisualizeData(String name, int fieldCount, String[] fieldTitle) {
        this(name, fieldCount, fieldTitle, 0, null, null);

    }

    public VisualizeData(String name, int fieldCount, String[] fieldTitle,
            int butCount, String[] butTitle, Function[] butActions) {
        this.fieldCount = fieldCount;
        fields = new JTextField[fieldCount];
        final JFrame frame = new JFrame(name);

        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                frame.setVisible(false);
                stop();
                frame.dispose();
            }
        });
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        JPanel pan = new JPanel();
        JPanel west = new JPanel();
        JPanel center = new JPanel();
        JPanel south = new JPanel();
        pan.setLayout(new BorderLayout());
        west.setLayout(new GridLayout(fieldCount, 1));
        center.setLayout(new GridLayout(fieldCount, 1));
        for (int i = 0; i < fieldCount; i++) {
            JLabel lab = new JLabel(fieldTitle[i]);
            // lab.setHorizontalAlignment(SwingConstants.RIGHT);
            west.add(lab);
            fields[i] = new JTextField(30);
            center.add(fields[i]);
        }
        pan.add(west, BorderLayout.WEST);
        pan.add(center, BorderLayout.CENTER);
        if (butCount > 0) {
            south.setLayout(new FlowLayout());
            for (int i = 0; i < butCount; i++) {
                JButton but = new JButton(butTitle[i]);
                final Function action = butActions[i];
                but.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        action.invoke();
                    }
                });
                south.add(but);
            }
            pan.add(south, BorderLayout.SOUTH);
        }
        frame.setContentPane(pan);
        frame.pack();
        frame.setVisible(true);
    }

    @Override
    public void processObject(Object o, int ID) throws IllegalArgumentException {
        if (ID >= 0 && ID < fieldCount)
            fields[ID].setText(o.toString());
        // fields[ID].repaint();
    }

}
