/*
 * Created on 24.07.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes.data;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.NoSuchElementException;

/**
 * @author beringer
 */
public class BinaryStreamReader extends AbstractDoubleIterator {

	DataInputStream ps;
	long count=0;
	
	public double min=Double.MAX_VALUE;
	public double max=-Double.MAX_VALUE;

	public BinaryStreamReader() {
		ps= null;
	}

	public BinaryStreamReader(String file, int header) throws FileNotFoundException {
		this(new FileInputStream(file),header);
	}

	public BinaryStreamReader(InputStream in, int header) {
		ps= new DataInputStream(new BufferedInputStream(in));
		try {
			for (int i=0;i<header;i++){
				ps.read();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public synchronized void exchangeStream(String newfile,int header) {
		try {
			exchangeStream(new FileInputStream(newfile),header);
		} catch (FileNotFoundException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
	}

	public synchronized void exchangeStream(InputStream newin,int header) {
		DataInputStream ps2= new DataInputStream(new BufferedInputStream(newin));
		try {
			if (ps != null) {
				ps.close();
			}
			for (int i=0;i<header;i++){
				ps2.read();
			}
		} catch (IOException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
		ps= ps2;
	}
	
	public boolean hasNext() {
		try {
			if (ps.available()>0) return true;
			else return false;
		} catch (IOException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
			return false;
		}
	}

	public synchronized double nextDouble() throws NoSuchElementException {
		if (ps == null)
			return 0.0;
		try {
			count++;
			double val=(double)ps.readDouble();
			if (val>max) {
				max=val;
				System.out.println("Min:"+min+"  Max:"+max);
			}
			if (val<min) {
				min=val;
				System.out.println("Min:"+min+"  Max:"+max);
			}
			return val;
		} catch (IOException e) {
			ps=null;
			System.out.println(count+" Daten gelesen");
			e.printStackTrace();
			return 0.0;
			//throw new NoSuchElementException();
			
		}
	}

	public synchronized void done(int id) {
		try {
			if (ps != null) {
				ps.close();
			}
		} catch (IOException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
	}

}
