/*
 * Created on 24.07.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes.data;

import java.io.BufferedOutputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import xxl.core.pipes.sinks.AbstractSink;

/**
 * @author beringer
 */
public class BinaryStreamSaver extends AbstractSink {

	DataOutputStream ps;
	
	public BinaryStreamSaver(){
		ps=null;
	}

	public BinaryStreamSaver(String file) throws FileNotFoundException {
		this(new FileOutputStream(file));
	}

	public BinaryStreamSaver(OutputStream out) {
		ps= new DataOutputStream(new BufferedOutputStream(out));
	}

	public synchronized void exchangeStream(String newfile) {
		try {
			exchangeStream(new FileOutputStream(newfile));
		} catch (FileNotFoundException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
	}

	public synchronized void exchangeStream(OutputStream newout) {
		DataOutputStream ps2= new DataOutputStream(new BufferedOutputStream(newout));
		try {
			if (ps!=null){
				ps.flush();
				ps.close();
			}
		} catch (IOException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
		ps= ps2;
	}

	public synchronized void processObject(Object ob, int id) {
		if (ps==null) return;
		double[][] arr= null;
		if (ob instanceof Number) {
			arr= new double[][] {{((Number) ob).doubleValue()}};
		} else if (ob instanceof double[]) {
			arr= new double[][] {(double[]) ob};
		} else {
			arr= (double[][]) ob;
		}
		int channels=arr.length;
		int len= arr[0].length;
		
		for (int i= 0; i < len; i++) {
		for (int c= 0; c < channels; c++) {
			try {
				ps.writeFloat((float) arr[c][i]);
			} catch (IOException e) {
				// XXX Auto-generated catch block
				e.printStackTrace();
			}
		}
		}
	}

	public synchronized void done(int id) {
		try {
			if (ps!=null){
				ps.flush();
				ps.close();
			}
		} catch (IOException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
	}

	
}
