/*
 * Created on 11.06.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes.data;

/**
 * @author beringer
 */
public class SinusTrendSeries extends TrendDataSeries {

	int windowSize;
	double pi2= 2 * Math.PI;

	public SinusTrendSeries(int period, int initLength, int seriesCount, int stepLength) {
		super(period, initLength, 5, 6, seriesCount, stepLength, 0.0, 0.0);

		windowSize= initLength;
		trends[0][0]= 1;
		trends[0][1]= 3;
		trends[0][2]= 0.55;
		trends[0][3]= 1.2;
		trends[0][4]= 5;
		trends[0][5]= 1.08;
		trends[1][0]= 1.4;
		trends[1][1]= 1;
		trends[1][2]= 0.95;
		trends[1][3]= 1;
		trends[1][4]= 3;
		trends[1][5]= 0.35;
		trends[2][0]= 1;
		trends[2][1]= 2;
		trends[2][2]= 6*0.75;
		trends[2][3]= 1.4;
		trends[2][4]= 5.5;
		trends[2][5]= 6;
		trends[3][0]= 1;
		trends[3][1]= 1.3;
		trends[3][2]= 1.29;
		trends[3][3]= 1.8;
		trends[3][4]= 4.1;
		trends[3][5]= 0.47;
		trends[4][0]= 1.3;
		trends[4][1]= 1.8;
		trends[4][2]= 7*0.75;
		trends[4][3]= 1;
		trends[4][4]= 3.6;
		trends[4][5]= 7;

		double epsmax= (windowSize/30);
		double epsmin= -epsmax;
		double fmin= 10;
		double fmax= 15;

		double epsmax2= 0.1;
		double epsmin2= 0.02;
		double fmin2= 5;
		double fmax2= 12;

		for (int i= 0; i < seriesCount; i++) {
			seriesNoise[i]= new double[4];
			seriesNoise[i][0]= Math.random() * (epsmax - epsmin) + epsmin;
			seriesNoise[i][1]= Math.random() * (fmax - fmin) + fmin;
			seriesNoise[i][2]= Math.random() * (epsmax2 - epsmin2) + epsmin2;
			seriesNoise[i][3]= Math.pow(2, Math.random() * (fmax2 - fmin2) + fmin2);
		}

	}

	/* (non-Javadoc)
	 * @see xxl.datamining.data.TrendDataSeries#computeNext(double[], double)
	 */
	public double computeNext(
		double[] trend,
		double[] noise,
		double offset,
		double var,
		long pos) {

		double relpos= pos + (noise[0] * Math.sin(pi2 * noise[1] * pos / windowSize));
		double val= trend[0] * Math.sin(trend[1] + pi2 * trend[2] * relpos / windowSize);
		val= val + trend[3] * Math.sin(trend[4] + pi2 * trend[5] * relpos / windowSize);
		double noisedval= val * (1 + noise[2] * Math.sin(pi2 * noise[3] * pos / windowSize));
		return offset + noisedval;
	}

}
