/*
 * Created on 24.07.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes.data;

import java.io.BufferedOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;

import xxl.core.pipes.sinks.AbstractSink;

/**
 * @author beringer
 */
public class StreamSaver extends AbstractSink {

	PrintStream ps;

	long nr = 0;

	String[] name;

	int channels;

	public StreamSaver(String name) {
		this(new String[] { name}, 1);
	}

	public StreamSaver(String[] name, int channels) {
		this.name = name;
		this.channels = channels;
		ps = null;
	}

	public StreamSaver(String file, String name) throws FileNotFoundException {
		this(new FileOutputStream(file), name);
	}

	public StreamSaver(OutputStream out, String name) {
		this(out, new String[] { name}, 1);
	}

	public StreamSaver(String file, String[] name, int channels)
			throws FileNotFoundException {
		this(new FileOutputStream(file), name, channels);
	}

	public StreamSaver(OutputStream out, String[] name, int channels) {
		ps = new PrintStream(new BufferedOutputStream(out));
		this.name = name;
		this.channels = channels;
		ps.print("ID");
		for (int i = 0; i < channels; i++) {
			ps.print("\t" + name[i]);
		}
		ps.print("\n");
		ps.print("INTEGER");
		for (int i = 0; i < channels; i++) {
			ps.print("\tDOUBLE");
		}
		ps.print("\n\n");
	}

	public synchronized void exchangeStream(String newfile, int channels, String[] name) {
		try {
			exchangeStream(new FileOutputStream(newfile),channels,name);
		} catch (FileNotFoundException e) {
			// XXX Auto-generated catch block
			e.printStackTrace();
		}
	}

	public synchronized void exchangeStream(OutputStream newout, int channels, String[] name) {
		PrintStream ps2 = new PrintStream(new BufferedOutputStream(newout));
		if (ps != null) {
			ps.flush();
			ps.close();
		}
		this.channels=channels;
		this.name=name;
		ps = ps2;
		ps.print("ID");
		for (int i = 0; i < channels; i++) {
			ps.print("\t" + name[i]);
		}
		ps.print("\n");
		ps.print("INTEGER");
		for (int i = 0; i < channels; i++) {
			ps.print("\tDOUBLE");
		}
		ps.print("\n\n");
	}

	public synchronized void processObject(Object ob, int id) {
		if (ps == null) return;
		double[][] arr = null;
		if (ob instanceof Number) {
			arr = new double[][] { { ((Number) ob).doubleValue()}};
		} else if (ob instanceof double[]) {
			arr = new double[][] { (double[]) ob};
		} else
			arr = (double[][]) ob;
		int channels=arr.length;
		int len = arr[0].length;
		
		int i = 0;
		while (i < len) {
			nr++;
			ps.print(nr);
			for (int c = 0; c < channels; c++) {
				ps.print("\t" + arr[c][i]);
			}
			ps.print("\n");
			i++;
		}
	}

	public synchronized void done(int id) {
		if (ps != null) {
			ps.flush();
			ps.close();
		}
	}
}