/*
 * Created on 11.06.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes.data;

import xxl.core.cursors.sources.Repeater;
import xxl.core.pipes.sources.AbstractSource;

/**
 * @author beringer
 */
public abstract class TrendDataSeries extends AbstractSource {
	
	protected double[][] trends;
	protected int trendCount;
	
	protected double[][] series;
	protected double[] seriesOffset;
	protected double[][] seriesNoise;
	protected double[] var;
	protected int seriesCount;
	protected int[] seriesTrend;
	
	protected int period;
	protected int initLength;
	protected int stepLength;
	protected long pos;
	protected boolean initPeriod;
	protected static  int noPeriod=1;
	
	public TrendDataSeries(int period,int initLength){
		super(noPeriod);
		//noPeriod=period;
		this.period=period;
		this.initLength=initLength;
		if (initLength<=0) {
			((Repeater)processor.getDelayManager()).update(new Long(period));
			initPeriod=false;
		}
		else {
			((Repeater)processor.getDelayManager()).update(new Long(noPeriod));
			initPeriod=true;
		}
		pos=0;
	}
	
	public TrendDataSeries(int period,int initLength,int trendCount, int trendLength, int seriesCount,int stepLength, double startMin, double startMax){
		this(period,initLength);
		initialize(trendCount, trendLength, seriesCount,stepLength,startMin, startMax);
	}
	
	public void initialize(int trendCount, int trendLength, int seriesCount,int stepLength, double startMin, double startMax){
		this.trendCount=trendCount;
		this.seriesCount=seriesCount;
		this.stepLength=stepLength;
		trends=new double[trendCount][trendLength];
		series=new double[seriesCount][stepLength];
		seriesNoise=new double[seriesCount][];
		seriesOffset=new double[seriesCount];
		seriesTrend=new int[seriesCount];
		int k=seriesCount/trendCount;
		var=new double[seriesCount];
		for (int i=0;i<k;i++)
			for (int j=0;(j<trendCount)&(i*trendCount+j<seriesCount);j++){ 
				seriesTrend[i*trendCount+j]=j;
				//System.out.println((i*trendCount+j)+":"+j);
			}
		for (int i=0;i<seriesCount;i++){
			seriesOffset[i]=(Math.random()*(startMax-startMin)+startMin);
			var[i]=1;//(Math.random()+0.5)*10;
			
		}
	}
	
	public void commitTrends(){}
	public void commitSeriesTrend(){}
	
	public abstract double computeNext(double[]trend, double[]noise, double last,double var,long pos);
	
	public Object next(){
		
		if (initPeriod){
			if (pos>=initLength){
				((Repeater)processor.getDelayManager()).update(new Long(period));
				initPeriod=false;
				System.out.println("period set:"+pos);
			}
		}
		//if (pos%1000==0) System.out.println(pos);
		long oldPos=pos;
		//System.out.println(oldPos+"  "+Thread.currentThread());
		pos+=stepLength;
		commitTrends();
		commitSeriesTrend();
		series=new double[seriesCount][stepLength];
		for (int i=0;i<seriesCount;i++){
			for (int j=0;j<stepLength;j++){
				double val=computeNext(trends[seriesTrend[i]],seriesNoise[i],seriesOffset[i],var[i],oldPos+j);
				series[i][j]=val;
			}
		}
		
		return series;
	}
	public int transfer(Object o) {
		return super.transfer(o);
	}
	/*public synchronized int transfer(Object o) {
		Object[] obs = (Object[])o;
		int counter = 0;
		if (sinks != null) {
			for (int i = 0; (sinks != null)&&(i < sinks.length); i++) {
				//System.out.println(sinks[i]);
				if (bitSet.get(i)) {
					sinks[i].process(obs[i], sinkIDs[i]);
					counter++;
				}
			}
		}
		if (measureOutputRate)
			outputCounter += counter;
		return counter;
	}*/

}
