package utils.visibility;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class Drawer extends DrawField2D {

    protected List<Drawable> drawables;

    public Drawer(int sizeX, int sizeY) {
        super(sizeX, sizeY);
        drawables=new ArrayList();
    }
    
    public Drawer(int sizeX, int sizeY,double minX, double maxX, double minY, double maxY) {
        super(sizeX,sizeY,minX,maxX,minY,maxY);
        drawables=new ArrayList();
    }
    
    public void add(Drawable drawable){
        drawables.add(drawable);
    }
    
    public void remove(Drawable drawable){
        drawables.remove(drawable);
    }
    
    public void redraw(){
        clear();
        for(Drawable d:drawables){
            d.draw(this);
        }
        repaint();
    }
    
    public void updated(Drawable draw){
        redraw();
    }
    
    
    
    
}
