package utils.visibility;

import java.awt.Color;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

public class ViewFunction {

    public static Color[] colors = new Color[] { Color.RED, Color.BLUE,
            Color.GREEN, Color.YELLOW, Color.CYAN, Color.MAGENTA, Color.PINK,
            Color.ORANGE, new Color(127, 255, 255), new Color(255, 127, 255),
            new Color(255, 255, 127), Color.BLACK };;

    double[][][] function;

    protected boolean fuzzy = false;

    DrawField2D draw;

    double minX;

    double maxX;

    double minY;

    double maxY;

    
    public ViewFunction(double[][] function, int width, int height,
            double minX, double maxX, double minY, double maxY, String title) {
        this(new double[][][]{function},width,height,minX,maxX,minY,maxY,title);
    }
    
    public ViewFunction(double[][][] function, int width, int height,
            double minX, double maxX, double minY, double maxY, String title) {
        this.function = function;
        fuzzy = false;
        this.minX = minX;
        this.maxX = maxX;
        this.minY = minY;
        this.maxY = maxY;

        final JFrame frame = new JFrame("View Function: " + title);
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                frame.setVisible(false);
                frame.dispose();
            }
        });
        frame.setSize(width, height);
        frame.setVisible(true);
        view(frame.getContentPane());
        draw();

    }

    public void view(final Container con) {

        draw = new DrawField2D(con.getWidth(), con.getHeight()) {

            public void redraw() {
                draw();
            }
        };
        draw.setMinMaxX(minX, maxX);
        draw.setMinMaxY(minY, maxY);
        con.add(draw);
    }

    public void draw() {

        for (int f = 0; f < function.length; f++) {
            int n = function[f].length;
            for (int i = 0; i < n; i++) {
                draw.drawPoint(function[f][i][0], function[f][i][1], colors[f],
                        8);
                if (i > 0) {
                    draw.drawLine(function[f][i - 1][0], function[f][i - 1][1],
                            function[f][i][0], function[f][i][1], colors[f]);
                }
            }
        }
    }

}
