

package weka.classifiers;

import java.util.Enumeration;

import weka.core.Instance;
import weka.core.Instances;


/**
 * @author beringer
 *
 */
public class OnLineEvaluator {
	
	protected OnLineClassifier classifier;
	protected Instances initInstances;
	protected Instances onLineInstances;
	
	public OnLineEvaluator(){
	}
	
	public OnLineEvaluator(OnLineClassifier classifier,Instances initInstances,Instances onLineInstances){
		this.classifier=classifier;
		this.initInstances=initInstances;
		this.onLineInstances=onLineInstances;
	}
	
	public void setClassifier(OnLineClassifier classifier){
		this.classifier=classifier;
	}
	
	public void setInitializeData(Instances initInstances){
		this.initInstances=initInstances;
	}
	
	public void setOnLineData(Instances onLineInstances){
		this.onLineInstances=onLineInstances;
	}
	
	public double evaluate(){
		try {
			classifier.buildClassifier(initInstances);
			Enumeration enum1=onLineInstances.enumerateInstances();
			int all=0;
			int correct=0;
			while(enum1.hasMoreElements()){
				Instance inst=(Instance)enum1.nextElement();
				int cls=(int)classifier.classifyInstance(inst);
				all++;
				if (cls==(int)inst.classValue()) correct++;
				classifier.updateClassifier(inst);
			}
			return correct/(double)all;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return Double.NaN;
	}

}
