package weka.classifiers.lazy;

import java.util.List;

import weka.classifiers.CaseBasedAlgorithm;
import weka.classifiers.OnLineClassifier;
import weka.core.Instance;
import weka.core.Instances;

public class CaseBasedClassifier extends OnLineClassifier implements CaseBasedAlgorithm{
    
    protected CaseBasedAlgorithm cb;
    
    protected OnLineClassifier cl;
    
    protected int k;
    
    
    public CaseBasedClassifier(CaseBasedAlgorithm cb, OnLineClassifier cl, int k){
        this.cb=cb;
        this.cl=cl;
        this.k=k;
        
    }

    @Override
    public void setOperativeAttributes(List usedAttributeList) {
        cl.setOperativeAttributes(usedAttributeList);
    }

    @Override
    public void updateClassifier(Instance inst) {
        cl.updateClassifier(inst);
    }

    @Override
    public void buildClassifier(Instances data) throws Exception {
        cl.buildClassifier(data);
    }

    public List getTrainInstances() {
        return cb.getTrainInstances();
    }

    public int getTrainInstancesCount() {
        return cb.getTrainInstancesCount();
    }

    public double classifyIB(Instance instance, int k) {
        return cb.classifyIB(instance,k);
    }
    
    public double classifyInstance(Instance inst){
        return cb.classifyIB(inst,k);
    }


}
