package weka.datagenerators;

import java.io.PrintStream;
import java.util.List;
import java.util.Random;

import weka.core.Attribute;
import weka.core.FastVector;
import weka.core.Instance;
import weka.core.Instances;
import weka.filters.Filter;
import weka.filters.unsupervised.attribute.Remove;

public class InstancesGenerator extends AdaptiveGenerator {

    protected Instances insts;
    protected int pos;
    
    public InstancesGenerator(Instances data, int attrib){
        //data.randomize(new Random());
        data.sort(attrib);
        Remove rem=new Remove();
        rem.setAttributeIndicesArray(new int[]{attrib});
        
        try {
            rem.setInputFormat(data);
            insts=Filter.useFilter(data,rem);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        pos=0;
    }
    
    public void update() {
    }

    protected Instance generate(int time) {
        double[] old=insts.instance(pos).toDoubleArray();
        double[] newVal=new double[old.length+1];
        System.arraycopy(old,0,newVal,1,old.length);
        newVal[0]=time;
        pos++;
        return new Instance(1.0,newVal);
    }

    public int getLabel(Instance point) {
        return (int)point.classValue();
    }

    public int getNoiseLabel(Instance point) {
        return getLabel(point);
    }

    public boolean isInitialised() {
        return true;
    }

    public void reset(Random rnd) {
        int pos=0;
        
    }
    
    public void reset() {
        int pos=0;
        
    }

    public Instances getInitData(int count) {
        Instances insts2 = new Instances(insts.relationName(), getAttsInfo(), count);
        for (int i = 0; i < count; i++) {
            insts2.add(generate(0));
        }
        insts2.setClassIndex(insts.classIndex()+1);
        return insts2;
    }

    public Instance generateExample(int time) {
        return generate(time);
    }

    protected FastVector getAttsInfo() {
        FastVector inf = new FastVector(insts.numAttributes()+1);
        inf.add(new Attribute("Time"));
        for (int i=0;i<insts.numAttributes();i++){
            inf.add(insts.attribute(i));
        }
        return inf;
    }

    public int getNumClasses() {
        return insts.classAttribute().numValues();
    }


    public double getMinimum(int dimension) {
        return insts.attribute(dimension+1).getLowerNumericBound();
    }

    public double getMaximum(int dimension) {
        return insts.attribute(dimension+1).getUpperNumericBound();
    }

    public void output(List data, PrintStream out) {
        // TODO Auto-generated method stub
        
    }

    public Instances defineDataFormat() {
        return new Instances(insts,0);
    }

    public Instance generateExample() {
        return null;
    }

    public Instances generateExamples() {
        return null;
    }

    public String generateFinished() {
        return null;
    }

    public boolean getSingleModeFlag() {
        return false;
    }

}
