/*
 * Created on 07.06.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package weka.multiValue.classifiers.rules;

import weka.classifiers.rules.CN2;
import weka.classifiers.rules.rise.SimpleConjunctiveRule;
import weka.core.FastVector;
import weka.core.Instance;
import weka.core.Instances;
import weka.core.OptionHandler;
import weka.multiValue.MVInstances;

/**
 * @author beringer
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class MVCN2 extends CN2 implements OptionHandler {
	
	public static class Rule extends SimpleConjunctiveRule {

		
		public Rule(Instances instances, boolean store) {
			super(instances,store);
		}

		public Rule(SimpleConjunctiveRule rule) {
			super(rule);
		}
		
		public void resetCoveredExamples(int capacity){
			coveredExamples=new FastVector(capacity);
		}

		public void addClasses(int[] classes) {
			for (int i= 0; i < classes.length; i++) {
				distribution[classes[i]]++;
			}
			distSum++;
		}

		public void addClasses(int[] classes, double count) {
			for (int i= 0; i < classes.length; i++) {
				distribution[classes[i]]++;
			}
			distSum += count;
		}

		
		public void computeDistribution(Instances insts) {
			MVInstances data=null;
			if (insts instanceof MVInstances) data=(MVInstances) insts;
			else data=(MVInstances)instances;
			resetDistribution();
			int size=insts.numInstances();
			for (int i=size-1;i>=0;i--){
				Instance inst= insts.instance(i);
				if (covers(inst)) {
					addClasses(data.getLabeledClasses(inst));
					if (storeCovered) coveredExamples.addElement(inst);
				}
			}
		}
		
		public void computeDistribution(FastVector insts) {
			MVInstances data=null;
			data=(MVInstances)instances;
			resetDistribution();
			int size=insts.size();
			for (int i=size-1;i>=0;i--){
				Instance inst= (Instance)insts.elementAt(i);
				if (covers(inst)) {
					addClasses(data.getLabeledClasses(inst));
					if (storeCovered) coveredExamples.addElement(inst);
				}
			}
		}
	}
	
	
	public void buildClassifier(Instances instances) throws Exception {
		if (!(instances instanceof MVInstances)) 
			instances=MVInstances.convertInstances(instances);
		super.buildClassifier(instances);
	}
	
	protected void computeUsedAttributes(Instances inst){
		MVInstances allData= (MVInstances)inst;
		usedAttribute= new boolean[allData.numAttributes()];

		for (int i= 0; i < allData.numAttributes(); i++) {
			if ((i != classAttr)
				&& (!allData.isClassAttribute(i))
				&& allData.attribute(i).isNominal()
				&& isUsedAttribute(i))
				usedAttribute[i]= true;
		}
	}
	
	protected SimpleConjunctiveRule getRule(Instances data){
		return new Rule(data,true);
	}
	
	protected SimpleConjunctiveRule getRule(SimpleConjunctiveRule rule){
		return new Rule(rule);
	}


}