/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.awt.toolbars;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import xxl.applications.gui.awt.AbstractToolBar;

/**
 * @author maxim
 * 
 */
//TODO make toolbar panel to look fine...
public final class ToolBarPanel extends JPanel {

	private Map toolBar2IdMap = new HashMap();

	public ToolBarPanel() {
		super(new FlowLayout(FlowLayout.LEFT));
	}
	
	public void addToolBar(AbstractToolBar toolbar) {
		toolBar2IdMap.put(toolbar.getName(), toolbar);
		add(toolbar);	
	}
	
	public void removeToolBar(String name) {
		Component c = (Component) toolBar2IdMap.remove(name);
		remove(c);
	}

	private class ToolBarMenu extends JPopupMenu {
						
	}

	private class MouseListener extends MouseAdapter {

		public void mousePressed(MouseEvent e) {
			if (e.isPopupTrigger()) {
			}
		}
	}

}
