/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.code.beaninfo;

import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;

import xxl.applications.gui.code.AbstractItem;
import xxl.applications.gui.graph.beaninfo.VertexBeanInfo;

/**
 * @author maxim
 */
public class AbstractItemBeanInfo extends VertexBeanInfo {

	public PropertyDescriptor[] getPropertyDescriptors() {
		PropertyDescriptor[] parent = super.getPropertyDescriptors();
		PropertyDescriptor[] desc = new PropertyDescriptor[parent.length + 3];
		System.arraycopy(parent, 0, desc, 0, parent.length);
		try {
			int i = parent.length;
			desc[i] = new PropertyDescriptor("valid", AbstractItem.class, "isValid", null);			
			desc[i + 1] = new PropertyDescriptor("enclosedType", AbstractItem.class,
					"getEnclosedType", null);
			desc[i + 1].setDisplayName("class");
			desc[i + 2] = new PropertyDescriptor("type", AbstractItem.class, "getDescription", null);
			desc[i + 2].setDisplayName("item type");			
		} catch (IntrospectionException ie) {
			return parent;
		}
		return desc;
	}
}
