/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.graph.event;

import java.util.EventObject;

import xxl.applications.gui.graph.Edge;
import xxl.applications.gui.graph.Graph;


public final class EdgeEvent extends EventObject {
	public static final int EDGE_ADDED = 0;
	public static final int EDGE_REMOVED = 1;
	public static final int EDGE_CHANGED = 2;

	private Edge edge;
	private int type;

	public EdgeEvent(Graph source, Edge edge, int type) {
		super(source);
		this.edge = edge;
		this.type = (type == 0 || type == 1) ? type : EdgeEvent.EDGE_CHANGED;
	}

	public int getType() {
		return type;
	}

	public Edge getEdge() {
		return edge;
	}

	public Graph getGraph() {
		return (Graph) getSource();
	}
}
