/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.property.editors;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyEditorSupport;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author maxim
 */
public class InplaceEditor extends PropertyEditorSupport {

	static final Dimension EDITOR_SIZE = new Dimension(120, 20);
	static final Dimension BUTTON_SIZE = new Dimension(20, 20);
	/** Component used for editing properties */
	private Component customEditor;
	private JTextField editorTF;
	private JButton customizerBtn;
	private JPanel panel;

	public InplaceEditor() {
		createComponents();
	}

	public Component getCustomEditor() {
		return panel;
	}

	public boolean supportsCustomEditor() {
		return true;
	}

	private void createComponents() {
		panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		editorTF = new JTextField();
		editorTF.setPreferredSize(EDITOR_SIZE);
		editorTF.setMaximumSize(EDITOR_SIZE);
		editorTF.setMinimumSize(EDITOR_SIZE);
		customizerBtn = new JButton("...");
		customizerBtn.setMaximumSize(BUTTON_SIZE);
		customizerBtn.setMinimumSize(BUTTON_SIZE);
		customizerBtn.setPreferredSize(BUTTON_SIZE);
		panel.add(editorTF);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(customizerBtn);
		panel.setAlignmentX(Component.LEFT_ALIGNMENT);
	}

	public static void main(String[] args) {
		JFrame f = new JFrame();
		f.addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent e) {
				JFrame frame = (JFrame) e.getSource();
				frame.dispose();
				System.exit(0);
			}
		});
		InplaceEditor editor = new InplaceEditor();
		f.getContentPane().add(editor.panel);
		f.pack();
		f.setVisible(true);
	}
}
