/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.serializer;
import java.lang.reflect.Method;

import com.thoughtworks.xstream.converters.reflection.Sun14ReflectionProvider;

/**
 * @author Tim Dörnemann
 * @version 0.1
 */

public class ReflectionProvider extends Sun14ReflectionProvider {
	static Object createInstance(Class c) {
		Object object = null;
		try {
			object = c.newInstance();
		} catch (Exception e) {
		// Instantiation errors are ok in this case, because the XStream
		// library does not need to class the classes constructor to restore
		// it. All we need is to invoke init() after calling the constructor
		// to restore EventListeners et cetera
		}
		return object;
	}
	
	public Object newInstance(Class c) {
		Object ret = null;
		Method initMethod;
		ret = createInstance(c);
		
		Method[] methods = c.getMethods();
		
		for( int i = 0; i < methods.length; i++)
			if( methods[i].getName().equals("init") ) {
				try {
					initMethod = c.getMethod("init");
					initMethod.invoke(ret);
				} catch (Exception e) {
					e.printStackTrace(); // should never happen ;)
				}
			}
			
		if (ret == null)
			return super.newInstance(c);
		
		return ret;
	}
}
