/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.serializer;

import java.awt.Point;

import xxl.applications.gui.graph.GraphElement;
import xxl.applications.gui.graph.Vertex;

import com.thoughtworks.xstream.alias.ClassMapper;
import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

/**
 * @author maxim
 */
//FIXME unfertig
public class VertexConverter implements Converter {

	private static Point DEFAULT_LOCATION = new Point();
	protected ClassMapper classMapper;

	public VertexConverter(ClassMapper classMapper) {
		if (classMapper == null)
			throw new IllegalArgumentException();
		this.classMapper = classMapper;
	}

	public boolean canConvert(Class type) {
		return Vertex.class.isAssignableFrom(type);
	}

	public void marshal(Object source, HierarchicalStreamWriter writer, MarshallingContext context) {
		if (source == null || !(source instanceof Vertex))
			throw new IllegalArgumentException();
		else {
			Vertex v = (Vertex) source;
			writer.startNode(classMapper.serializedClass(v.getClass()));
			writer.addAttribute(GraphElement.NAME_PROPERTY, v.getName());
			writer.addAttribute(GraphElement.SELECTED_PROPERTY, String.valueOf(v.isSelected()));
			writer.addAttribute(GraphElement.VISIBLE_PROPERTY, String.valueOf(v.isVisible()));
			if (!v.getLocation().equals(DEFAULT_LOCATION)) {
				writer.startNode(GraphElement.LOCATION_PROPERTY);
				context.convertAnother(v.getLocation());
				writer.endNode();
			}
			if (v.getParent() != null) {
				//XXX save parent
			}
			writer.endNode();
		}
	}

	public Object unmarshal(HierarchicalStreamReader reader, UnmarshallingContext context) {
		Class type;
		String name;
		Point location;
		boolean selected;
		boolean visible;
		while (reader.hasMoreChildren()) {
			reader.moveDown();
			name = reader.getAttribute(GraphElement.NAME_PROPERTY);
			selected = Boolean.valueOf(reader.getAttribute(GraphElement.SELECTED_PROPERTY)).booleanValue();
			visible = Boolean.valueOf(reader.getAttribute(GraphElement.VISIBLE_PROPERTY)).booleanValue();
			reader.moveDown();
			type = classMapper.realClass(reader.getNodeName());
			if(type.equals(Point.class)) {
				
			}
			reader.moveUp();
			reader.moveDown();
			reader.moveUp();
		}
		return null;
	}
}
