/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.windows;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import xxl.applications.gui.util.Utilities;

/**
 * @author maxim
 */
public class AboutDialog extends JDialog {
	private static JDialog dlg;	

	private AboutDialog() {
		super(MainFrame.getInstance(), "About", true);
		JPanel imagedPanel = new JPanel();
		imagedPanel.add(new ImageComponent());
		JTabbedPane tabs = new JTabbedPane();
		tabs.addTab("About", imagedPanel);
		getContentPane().add(tabs, BorderLayout.CENTER);
	}

	private static Image getImage() {		
		return Utilities.loadImage("xxl/applications/gui/windows/resources/XXL-Logo.jpg");
	}

	private static class ImageComponent extends JComponent {
		protected Image img;

		public ImageComponent() {
			img = new ImageIcon(getImage()).getImage();
		}

		public void paint(Graphics g) {
			g.drawImage(img, 0, 0, null);
		}

		public void update(Graphics g) {
			paint(g);
		}

		public Dimension getPreferredSize() {
			return new Dimension(img.getWidth(null), img.getHeight(null));
		}
	}

	public static void showAboutDlg() {
		if (dlg == null) {		
			dlg = new AboutDialog();
			dlg.pack();
		}
		dlg.setLocationRelativeTo(dlg.getParent());
		dlg.setVisible(true);
	}

}
