/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.windows;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JRootPane;
import javax.swing.ListSelectionModel;

/**
 *
 * @author  maxim
 */
final class NewPanel extends javax.swing.JPanel {
	private DialogDisplayer dialog;
	private static Integer CANCEL = new Integer(-1);

	/** Creates new form NewPanel */
	public NewPanel(DialogDisplayer parent) {
		initComponents();
		dialog = parent;
		Dimension d = new Dimension(130, 60);
		templateList.setMaximumSize(d);
		templateList.setPreferredSize(d);
		JRootPane root = dialog.getRootPane();		
		if (root != null)
			root.setDefaultButton(OKButton);		
		DefaultListModel model = new DefaultListModel();
		for (int i = 0; i < MainFrame.NEW_DESCRIPTION.length; i++) {
			model.addElement(MainFrame.NEW_DESCRIPTION[i]);
		}
		templateList.setModel(model);
		templateList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		templateList.setSelectedIndex(0);
		OKButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doOnOK();
			}
		});

		CancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doOnCancel();
			}
		});
	}

	private void doOnOK() {
		dialog.setValue(new Integer(templateList.getSelectedIndex()));
		dialog.setVisible(false);
		dialog.dispose();
	}

	private void doOnCancel() {
		dialog.setValue(CANCEL);
		dialog.setVisible(false);
		dialog.dispose();
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        OKButton = new javax.swing.JButton();
        CancelButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        templateList = new javax.swing.JList();

        setLayout(new java.awt.GridBagLayout());

        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(11, 11, 11, 11)));
        setPreferredSize(new java.awt.Dimension(391, 152));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        OKButton.setText("OK");
        OKButton.setMaximumSize(new java.awt.Dimension(100, 23));
        OKButton.setMinimumSize(new java.awt.Dimension(100, 23));
        OKButton.setPreferredSize(new java.awt.Dimension(100, 23));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        jPanel1.add(OKButton, gridBagConstraints);

        CancelButton.setText("Cancel");
        CancelButton.setMaximumSize(new java.awt.Dimension(100, 23));
        CancelButton.setMinimumSize(new java.awt.Dimension(100, 23));
        CancelButton.setPreferredSize(new java.awt.Dimension(100, 23));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel1.add(CancelButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        add(jPanel1, gridBagConstraints);

        jScrollPane1.setViewportView(templateList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 11);
        add(jScrollPane1, gridBagConstraints);

    }//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton CancelButton;
    private javax.swing.JButton OKButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList templateList;
    // End of variables declaration//GEN-END:variables
	
}
