/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.windows.wizards;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Enumeration;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import xxl.applications.gui.code.AbstractItem;

/**
 *
 * @author  maxim
 */
final class AddStep1Panel extends JPanel {
    private AddStep1 parentStep;
    private ItemListener itemListener = new ItemListener(){
        public void itemStateChanged(ItemEvent ie)  {
            Object source = ie.getItemSelectable();
            if(source == classRadioButton) {
                parentStep.setSelectedType(AbstractItem.CLASS_ITEM);
            }
            else if(source == objectRadioButton){
                parentStep.setSelectedType(AbstractItem.OBJECT_ITEM);
            }
            else if(source == primitiveRadioButton) {
                parentStep.setSelectedType(AbstractItem.PRIMITIVE_ITEM);
            }
            else if(source == arrayRadioButton) {
                parentStep.setSelectedType(AbstractItem.ARRAY_ITEM);
            }
        }
    };
    
    /** Creates new form AddStep1Panel */
    public AddStep1Panel(AddStep1 step) {
        parentStep = step;
        initComponents();
        setBorder(BorderFactory.createEmptyBorder(0, 11, 11, 11));
        for( Enumeration e = typesButtonGroup.getElements(); e.hasMoreElements(); ) {
            JRadioButton button = (JRadioButton) e.nextElement();
            button.addItemListener(itemListener);
        }
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        typesButtonGroup = new javax.swing.ButtonGroup();
        typesPanel = new javax.swing.JPanel();
        classRadioButton = new javax.swing.JRadioButton();
        objectRadioButton = new javax.swing.JRadioButton();
        primitiveRadioButton = new javax.swing.JRadioButton();
        arrayRadioButton = new javax.swing.JRadioButton();

        setLayout(new java.awt.GridBagLayout());

        typesPanel.setLayout(new javax.swing.BoxLayout(typesPanel, javax.swing.BoxLayout.Y_AXIS));

        classRadioButton.setText("Class Item");
        typesButtonGroup.add(classRadioButton);
        typesPanel.add(classRadioButton);

        objectRadioButton.setText("Object Item");
        typesButtonGroup.add(objectRadioButton);
        typesPanel.add(objectRadioButton);

        primitiveRadioButton.setText("Primitive Item");
        typesButtonGroup.add(primitiveRadioButton);
        typesPanel.add(primitiveRadioButton);

        arrayRadioButton.setText("Array Item");
        typesButtonGroup.add(arrayRadioButton);
        arrayRadioButton.setEnabled(false);
        typesPanel.add(arrayRadioButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(typesPanel, gridBagConstraints);

    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton arrayRadioButton;
    private javax.swing.JRadioButton classRadioButton;
    private javax.swing.JRadioButton objectRadioButton;
    private javax.swing.JRadioButton primitiveRadioButton;
    private javax.swing.ButtonGroup typesButtonGroup;
    private javax.swing.JPanel typesPanel;
    // End of variables declaration//GEN-END:variables
    
}
