/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.windows.wizards;

import javax.swing.JDialog;
import javax.swing.JFrame;

import xxl.applications.gui.wizard.JWizardPane;
import xxl.applications.gui.wizard.WizardStep;

/**
 *
 * @author  maxim
 */
public final class AddWizard extends JWizardPane {
	/** should be conform with AbstractItem type */
	public static final String ITEM_TYPE_PROPERTY = "selectedItem";
	public static final String ITEM_NAME_PROPERTY = "itemName";
	public static final String ITEM_CLASS_PROPERTY = "itemClass";
	public static final String ITEM_CODE_PROPERTY = "itemCode";
	public static final String ITEM_LENGTH_PROPERTY = "itemLength";
	public static final String ITEM_INITVALUE_PROPERTY = "itemValue";

	/** Creates a new instance of AddWizard */
	public AddWizard() {
		super(toArray());
	}

	public AddWizard(String clazz) {
		super(toArray2());
	}

	private static WizardStep[] toArray() {
		return new WizardStep[] { new AddStep1(), new AddStep2(), new AddStep3()};
	}

	private static WizardStep[] toArray2() {
		return new WizardStep[] { new AddStep2(), new AddStep3()};
	}

	public static void main(String[] args) {
		JFrame frame = new JFrame();
		JWizardPane wizard = new AddWizard();
		JDialog dialog = wizard.createDialog(frame, "Testing add Wizard");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
		dialog.setVisible(true);

	}
}
