/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.windows.wizards;

import xxl.applications.gui.wizard.JWizardPane;
import xxl.applications.gui.wizard.WizardStep;

/**
 * Wizard for adding a new Constructor or Method call to ClassGraph
 * @author maxim
 */
public final class ConstructorWizard extends JWizardPane {
	
    public static final String SOURCE_ITEM_PROPERTY = "fromVertex";
	public static final String TARGET_ITEM_PROPERTY = "toVertex";	
    /** property key this step puts into after completion */
    static final String SELECTED_CALL_PROPERTY = "selectedCall";
	
	public ConstructorWizard() {
		super(toArray());         
	}    

	private static WizardStep[] toArray() {
		return new WizardStep[] {new ConstructorFirstStep(), new ConstructorSecondStep()};
	}	
}
