/* XXL: The eXtensible and fleXible Library for data processing

Copyright (C) 2000-2006 Prof. Dr. Bernhard Seeger
                        Head of the Database Research Group
                        Department of Mathematics and Computer Science
                        University of Marburg
                        Germany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
USA

    http://www.xxl-library.de

bugs, requests for enhancements: request@xxl-library.de

If you want to be informed on new versions of XXL you can
subscribe to our mailing-list. Send an email to

    xxl-request@lists.uni-marburg.de

without subject and the word "subscribe" in the message body.
*/

package xxl.applications.gui.windows.wizards;

import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

import xxl.applications.gui.code.ConstructorCall;
import xxl.applications.gui.code.Type;

/**
 * @author  maxim
 */
final class ParamsTableModel extends AbstractTableModel {
    private static final String [] NAMES = {"Type", "Set"};
    private ArrayList elements;
    
    /** Creates a new instance of ParamsTableModel */
    public ParamsTableModel(ConstructorCall call) {
        elements = new ArrayList(call.getParamCount());
        for(int i = 0; i < call.getParamCount(); i++) {
            Object [] row = new Object[2];
            row[0] = call.getParamType(i);
            row[1] = Boolean.valueOf(call.isParameterSet(i));
            elements.add(row);
        }
    }
    
    public int getColumnCount() {
        return NAMES.length;
    }
    
    public int getRowCount() {
        return elements.size();
    }
    
    public String getColumnName(int column) {
        return NAMES[column];
    }
    
    public Object getValueAt(int rowIndex, int columnIndex) {
        Object[] row = (Object[]) elements.get(rowIndex);
        return row[columnIndex];
    }
    
    public Class getColumnClass(int columnIndex) {
        if(columnIndex == 1) return Boolean.class;
        //force to use TypeTableCellRenderer
        return Type.class;
    }
}
