/*  
   NEXMark Generator -- Niagara Extension to XMark Data Generator

   Acknowledgements:
   The NEXMark Generator was developed using the xmlgen generator 
   from the XMark Benchmark project as a basis. The NEXMark
   generator generates streams of auction elements (bids, items
   for auctions, persons) as opposed to the auction files
   generated by xmlgen.  xmlgen was developed by Florian Waas.
   See http://www.xml-benchmark.org for information.

   Copyright (c) Dept. of  Computer Science & Engineering,
   OGI School of Science & Engineering, OHSU. All Rights Reserved.

   Permission to use, copy, modify, and distribute this software and
   its documentation is hereby granted, provided that both the
   copyright notice and this permission notice appear in all copies
   of the software, derivative works or modified versions, and any
   portions thereof, and that both notices appear in supporting
   documentation.

   THE AUTHORS AND THE DEPT. OF COMPUTER SCIENCE & ENGINEERING 
   AT OHSU ALLOW USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION, 
   AND THEY DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY DAMAGES 
   WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.

   This software was developed with support from NSF ITR award
   IIS0086002 and from DARPA through NAVY/SPAWAR 
   Contract No. N66001-99-1-8098.

*/

package xxl.applications.pipes.auctions.nexmark;

class BigValueGen {

    public static final int NUM_CITIES = 265;
    public static final String cities[] = {
    "Abidjan","Abu","Acapulco","Aguascalientes","Akron","Albany",
    "Albuquerque","Alexandria","Allentown","Amarillo","Amsterdam",
    "Anchorage","Appleton","Aruba","Asheville","Athens","Atlanta", // 
    "Augusta","Austin","Baltimore","Bamako","Bangor","Barbados",
    "Barcelona","Basel","Baton","Beaumont","Berlin","Bermuda","Billings",
    "Birmingham","Boise","Bologna","Boston","Bozeman","Brasilia",
    "Brunswick","Brussels","Bucharest","Budapest","Buffalo","Butte",
    "Cairo","Calgary","Cancun","Cape","Caracas","Casper","Cedar",
    "Charleston","Charlotte","Charlottesville","Chattanooga","Chicago",
    "Chihuahua","Cincinnati","Ciudad","Cleveland","Cody","Colorado",
    "Columbia","Columbus","Conakry","Copenhagen","Corpus","Cozumel",
    "Dakar","Dallas","Dayton","Daytona","Denver","Des","Detroit","Dothan",
    "Dubai","Dublin","Durango","Durban","Dusseldorf","East","El","Elko",
    "Evansville","Fairbanks","Fayetteville","Florence","Fort","Fortaleza",
    "Frankfurt","Fresno","Gainesville","Geneva","George","Glasgow",
    "Gothenburg","Grand","Great","Green","Greensboro","Greenville",
    "Grenada","Guadalajara","Guangzhou","Guatemala","Guaymas","Gulfport",
    "Gunnison","Hamburg","Harrisburg","Hartford","Helena","Hermosillo",
    "Honolulu","Houston","Huntington","Huntsville","Idaho","Indianapolis",
    "Istanbul","Jackson","Jacksonville","Johannesburg","Kahului",
    "Kalamazoo","Kalispell","Kansas","Key","Kiev","Killeen","Knoxville",
    "La","Lafayette","Lansing","Las","Lawton","Leon","Lexington","Lima",
    "Lisbon","Little","Lome","London","Long","Lorient","Los","Louisville",
    "Lubbock","Lynchburg","Lyon","Macon","Madison","Madrid","Manchester",
    "Mazatlan","Melbourne","Memphis","Merida","Meridian","Mexico","Miami",
    "Milan","Milwaukee","Minneapolis","Missoula","Mobile","Monroe",
    "Monterrey","Montgomery","Montreal","Moscow","Mulhouse","Mumbai",
    "Munich","Myrtle","Nagoya","Nashville","Nassau","New","Newark",
    "Newburgh","Newcastle","Nice","Norfolk","Oakland","Oklahoma","Omaha",
    "Ontario","Orange","Orlando","Ouagadougou","Palm","Panama","Paris",
    "Pasco","Pensacola","Philadelphia","Phoenix","Pittsburgh","Pocatello",
    "Port","Portland","Porto","Prague","Providence","Providenciales",
    "Puebla","Puerto","Raleigh","Rapid","Reno","Richmond","Rio","Roanoke",
    "Rochester","Rome","Sacramento","Salt","Salvador","San","Santiago",
    "Sao","Sarasota","Savannah","Seattle","Shannon","Shreveport","South",
    "Spokane","St","Stockholm","Stuttgart","Sun","Syracuse","Tallahassee",
    "Tampa","Tapachula","Texarkana","Tokyo","Toledo","Toronto","Torreon",
    "Toulouse","Tri","Tucson","Tulsa","Turin","Twin","Vail","Valdosta",
    "Vancouver","Venice","Veracruz","Vienna","Villahermosa","Warsaw",
    "Washington","West","White","Wichita","Wilkes","Wilmington",
    "Windhoek","Worcester","Zihuatenejo","Zurich"
    };

    public static final int NUM_COUNTRIES = 232;
    public static final String countries[] = {
    "United States","Afghanistan","Albania","Algeria","American Samoa",
    "Andorra","Angola","Anguilla","Antarctica","Antigua","Argentina",
    "Armenia","Aruba","Australia","Austria","Azerbaijan","Bahamas",
    "Bahrain","Bangladesh","Barbados","Belarus","Belgium","Belize",
    "Benin","Bermuda","Bhutan","Bolivia","Botswana","Brazil",
    "British Indian Ocean Territory","British Virgin Islands",
    "Brunei Darussalam","Bulgaria","Burkina Faso","Burundi",
    "Cacos Islands","Cambodia","Cameroon","Canada","Cape Verde",
    "Cayman Islands","Central African Republic","Chad","Chile","China",
    "Christmas Island","Colombia","Comoros","Congo","Cook Islands",
    "Costa Rica","Croatia","Cuba","Cyprus","Czech Republic","Denmark",
    "Djibouti","Dominica","Dominican Republic","East Timor","Ecuador",
    "Egypt","El Salvador","Equatorial Guinea","Eritrea","Estonia",
    "Ethiopia","Falkland Islands","Faroe Islands","Fiji","Finland",
    "France","French Guiana","French Polynesia",
    "French Southern Territory","Futuna Islands","Gabon","Gambia",
    "Georgia","Germany","Ghana","Gibraltar","Greece","Greenland",
    "Grenada","Guadeloupe","Guam","Guatemala","Guinea","Guyana","Haiti",
    "Heard and Mcdonald Island","Honduras","Hong Kong","Hungary",
    "Iceland","India","Indonesia","Iran","Iraq","Ireland","Israel",
    "Italy","Ivory Coast","Jamaica","Japan","Jordan","Kazakhstan","Kenya",
    "Kiribati","Korea, Democratic People's Rep","Korea, Republic Of",
    "Kuwait","Kyrgyzstan","Lao People's Democratic Republ","Latvia",
    "Lebanon","Lesotho","Liberia","Libyan Arab Jamahiriya","Lithuania",
    "Luxembourg","Macau","Macedonia","Madagascar","Malawi","Malaysia",
    "Maldives","Mali","Malta","Marshall Islands","Martinique",
    "Mauritania","Mauritius","Mayotte","Mexico","Micronesia",
    "Moldova, Republic Of","Monaco","Mongolia","Montserrat","Morocco",
    "Mozambique","Myanmar","Namibia","Nauru","Nepal","Netherlands",
    "Netherlands Antilles","New Caledonia","New Zealand","Nicaragua",
    "Niger","Nigeria","Niue","Norfolk Island","Northern Mariana Islands",
    "Norway","Oman","Pakistan","Palau","Panama","Papua New Guinea",
    "Paraguay","Peru","Philippines","Poland","Portugal","Puerto Rico",
    "Qatar","Reunion","Romania","Russian Federation","Rwanda",
    "Saint Kitts","Samoa","San Marino","Sao Tome","Saudi Arabia",
    "Senegal","Seychelles","Sierra Leone","Singapore","Slovakia",
    "Slovenia","Solomon Islands","Somalia","South Africa","South Georgia",
    "Spain","Sri Lanka","St. Helena","St. Lucia","St. Pierre",
    "St. Vincent and Grenadines","Sudan","Suriname",
    "Svalbard and Jan Mayen Island","Swaziland","Sweden","Switzerland",
    "Syrian Arab Republic","Taiwan","Tajikistan","Tanzania","Thailand",
    "Togo","Tokelau","Tonga","Trinidad","Tunisia","Turkey","Turkmenistan",
    "Turks Islands","Tuvalu","Uganda","Ukraine","United Arab Emirates",
    "United Kingdom","Uruguay","Us Minor Islands","Us Virgin Islands",
    "Uzbekistan","Vanuatu","Vatican City State","Venezuela","Viet Nam",
    "Western Sahara","Yemen","Zaire","Zambia","Zimbabwe"
};

    //int countries_USA=0;
    public static final int NUM_EMAILS = 179;
    public static final String emails[] = {
    "ab.ca","ac.at","ac.be","ac.jp","ac.kr","ac.uk","acm.org",
    "airmail.net","arizona.edu","ask.com","att.com","auc.dk","auth.gr",
    "baylor.edu","bell-labs.com","bellatlantic.net","berkeley.edu",
    "brandeis.edu","broadquest.com","brown.edu","cabofalso.com","cas.cz",
    "clarkson.edu","clustra.com","cmu.edu","cnr.it","co.in","co.jp",
    "cohera.com","columbia.edu","compaq.com","computer.org",
    "concentric.net","conclusivestrategies.com","concordia.ca",
    "cornell.edu","crossgain.com","csufresno.edu","cti.gr","cwi.nl",
    "cwru.edu","dauphine.fr","dec.com","du.edu","duke.edu",
    "earthlink.net","edu.au","edu.cn","edu.hk","edu.sg","emc.com",
    "ernet.in","evergreen.edu","fernuni-hagen.de","filelmaker.com",
    "filemaker.com","forth.gr","forwiss.de","fsu.edu","gatech.edu",
    "gmu.edu","gte.com","hitachi.com","hp.com","ibm.com","imag.fr",
    "indiana.edu","infomix.com","informix.com","inria.fr","intersys.com",
    "itc.it","labs.com","lante.com","lbl.gov","lehner.net","llnl.gov",
    "lri.fr","lucent.com","memphis.edu","microsoft.com","mit.edu",
    "mitre.org","monmouth.edu","msn.com","msstate.edu","ncr.com",
    "neu.edu","newpaltz.edu","njit.edu","nodak.edu","ntua.gr","nwu.edu",
    "nyu.edu","ogi.edu","okcu.edu","oracle.com","ou.edu","panasonic.com",
    "pi.it","pitt.edu","poly.edu","poznan.pl","prc.com","propel.com",
    "purdue.edu","rice.edu","rpi.edu","rutgers.edu","rwth-aachen.de",
    "savera.com","sbphrd.com","sds.no","sdsc.edu","sfu.ca",
    "sleepycat.com","smu.edu","solidtech.com","stanford.edu","sun.com",
    "sunysb.edu","sybase.com","telcordia.com","temple.edu","toronto.edu",
    "tue.nl","twsu.edu","ualberta.ca","ubs.com","ucd.ie","ucdavis.edu",
    "ucf.edu","ucla.edu","ucr.edu","ucsb.edu","ucsd.edu","ufl.edu",
    "uga.edu","uic.edu","uiuc.edu","ul.pt","umass.edu","umb.edu",
    "umd.edu","umich.edu","umkc.edu","unbc.ca","unf.edu",
    "uni-freiburg.de","uni-mannheim.de","uni-marburg.de","uni-mb.si",
    "uni-muenchen.de","uni-muenster.de","uni-sb.de","uni-trier.de",
    "unical.it","unizh.ch","unl.edu","upenn.edu","uqam.ca","uregina.ca",
    "usa.net","ust.hk","uta.edu","utexas.edu","uu.se","uwaterloo.ca",
    "uwindsor.ca","uwo.ca","verity.com","versata.com","washington.edu",
    "whizbang.com","wisc.edu","wpi.edu","yahoo.com","yorku.ca",
    "zambeel.com"
    };

    public static final int NUM_PROVINCES = 51;
    public static final String provinces[] = {
    "Alabama","Alaska","Arizona","Arkansas","California","Colorado",
    "Connecticut","Delaware","District Of Columbia","Florida","Georgia",
    "Hawaii","Idaho","Illinois","Indiana","Iowa","Kansas","Kentucky",
    "Louisiana","Maine","Maryland","Massachusetts","Michigan","Minnesota",
    "Mississipi","Missouri","Montana","Nebraska","Nevada","New Hampshire",
    "New Jersey","New Mexico","New York","North Carolina","North Dakota",
    "Ohio","Oklahoma","Oregon","Pennsylvania","Rhode Island",
    "South Carolina","South Dakota","Tennessee","Texas","Utah","Vermont",
    "Virginia","Washington","West Virginia","Wisconsin","Wyoming"
    };

    public static final int NUM_EDUCATION = 4;
    public static final String education[] = {
	"High School", "College", "Graduate School", "Other"
    };
}
