/*
 * Created on 28.08.2006
 */
package xxl.core.pipes.scheduler;

/**
 * set of implemented operator-scheduling strategies
 * 
 * used by StrategyFactory
 * 
 */

public enum Strategies {

        /**
         * Random-Scheduling
         */
        RANDOM,

        /**
         * Round-Robin-Scheduling
         */
        ROUNDROBIN,

        /**
         * FCFS-Scheduling 
         */
        FCFS,

        /**
         * Comparator-Scheduling
         */
        COMPARATOR,

        /**
         * Shortestpath
         */
        SHORTESTPATH,

        /**
         * Chain-Scheduling 
         */
        CHAIN,

        /**
         * naive Balanced ApplicationTime Advancement
         */
        BATANAIVE,
        
        /**
         * naive BATA-Strategie mit Processor
         */
        LAZYBATANAIVE,
        
        /**
         * Balanced ApplicationTime Advancement path based
         */
        BATABU,
        
        /**
         * Balanced ApplicationTime Advancement periodically locally balanced
         */
        BATATD,
        
        /**
         * Balanced ApplicationTime Advancement only global advancement
         */
        BATATDWC,

        /**
         * shortest path with processors
         */
        TSP,

        /**
         * Mixed-Strategy
         */
        MIXED,

        /**
         * MinCost-Strategy 
         */
        MINCOST,

        /**
         * MinLatency-Strategy 
         */
        MINLATENCY,

        /**
         * MinMemoryStrategy 
         */
        MINMEMORY,

        /**
         * PathCapacity-Strategiy
         */
        PATHCAPACITY,
        
        /**
         *  Greedy-Strategy
         */
        GREEDY,
        
        /**
         * Segment-Strategy
         */
        SEGMENT,
        
        /**
         * Simplified Segment-Strategy
         */
        SIMPLIFIEDSEGMENT,
        
        /**
         *  Chain without unnecessary bufferpipes
         */
        OPTIMIZEDCHAIN,
        
        /**
         * Most tuples in Queue
         */
        MTQ,
        
        /**
         * preemptive ratebased strategy
         */
        PREEMPTIVERATEBASED,
        
        /**
         * Threshold Strategy
         */
        THRESHOLD
    
}
