package applications.pipes;

import java.util.Random;

import pipes.Blocker2;
import pipes.ClusterVisualizer;
import pipes.DFTNormWeightedStreams;
import pipes.FuzzyStreamCluster;
import pipes.MultiSource;
import pipes.data.SyntheticRealIterators;
import xxl.core.pipes.operators.identities.BufferPipe;
import xxl.core.pipes.scheduler.Controllable;
import xxl.core.pipes.scheduler.RoundRobinStrategy;
import xxl.core.pipes.scheduler.StrategyProcessor;
import xxl.core.pipes.sources.Source;

public class FuzzyClusterStreams {

    /**
     * @param args
     */
    public static void main(String[] args) {
        test1();
    }
    
    public static void test1() {
        int count = 30;
        int blockSize = 128;
        int blockCount = 8;
        int dftCount = 30;
        // int classes= 2;
        // int diffClasses= 4;
        int maxClasses = 12;
        double lastWeight = 0.5;
        double weight = Math.pow(lastWeight, 1.0 / (blockSize * blockCount));

        int windowSize= blockSize * blockCount;
        String[] obsStreams = new String[count];
        int[] lengths=new int[count];
        boolean[] autosize=new boolean[count];
        double[] min=new double[count];
        double[] max=new double[count];
        for (int i = 0; i < count; i++) {
            obsStreams[i] = "Stream Nr." + i;
            lengths[i]=windowSize;
            autosize[i]=true;
            min[i]=0;
            max[i]=1;
        }

        final MultiSource ms = new MultiSource(SyntheticRealIterators
                .getFactory(6, count, blockSize,new Random()), count, 1000,
                blockSize);
        ms.setCloseMode(Source.AUTOMATIC_CLOSE);
        
//        VisualizeStreams visStreams = new VisualizeStreams("Streams", count,
//                obsStreams, lengths, autosize, min, max, 0, null, null);

        Blocker2 bl = new Blocker2(count, 1);
        for (int i = 0; i < count; i++) {
            ms.subscribe(bl, i,i);
            bl.addSource(ms, i);
            
//            ms.subscribe(visStreams, i);
//            visStreams.addSource(ms, i);
        }
        BufferPipe dc = new BufferPipe(bl, 1, 1);
        StrategyProcessor proc = new StrategyProcessor(new RoundRobinStrategy(
                new Controllable[] { dc }), 0, 2500);
        proc.start();

        DFTNormWeightedStreams dft = new DFTNormWeightedStreams(obsStreams,
                count, blockSize, blockCount, dftCount, weight, bl
                        .getFloatPool());
        dft.addSource(dc, 0);
        dc.subscribe(dft, 0);


//        StreamCluster wcs = new StreamCluster(obsStreams, count, blockCount,
//                dftCount, maxClasses, 2);
        
        FuzzyStreamCluster wcs = new FuzzyStreamCluster(obsStreams, count,
                blockCount, dftCount, maxClasses,2, 6, 2.0,1000);
        // new FuzzyStreamCluster(obsStreams, count, blockCount, dftCount,
        // maxClasses, 2, 2.0,15.0);
        dft.subscribe(wcs, 0);
        wcs.addSource(dft, 0);

        wcs.setBufferPipe(dc);
        
        ClusterVisualizer cv = new ClusterVisualizer(obsStreams, maxClasses,
                true);
        wcs.subscribe(cv, 0);
        cv.createFrame("Cluster");
        cv.addSource(wcs, 0);

        ms.open();
    }

}
