/*
 * Created on 15.05.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package clustering;

import java.util.HashSet;
import java.util.Set;

import xxl.core.functions.Function;


/**
 * @author beringer
 */
public class FuzzyKMeansUtils {
    
    static public Initialization INITALIZE = new Initialization() {
        public void invoke(KMeansState state) {
            Function copyFunction=((FuzzyKMeansState)state).fkmc.getCopyFunction();
            //int sp = state.dataCount / state.clusterCount - 1;
            for (int i = 0; i < state.clusterCount; i++) {
                state.kMeans[i] = copyFunction.invoke(state.data[i], state.kMeans[i]);
            }

        }
    };

    static public Initialization INITALIZE_RANDOM = new Initialization() {
        public void invoke(KMeansState state) {
            Function copyFunction=((FuzzyKMeansState)state).fkmc.getCopyFunction();
            Set choiced=new HashSet();
            for (int i = 0; i < state.clusterCount; i++) {
                int sel=0;
                do{
                    sel=(int) (Math.random() * state.dataCount);
                }while (choiced.contains(new Integer(sel)));
                choiced.add(new Integer(sel));
                state.kMeans[i] = copyFunction.invoke(
                        state.data[sel], state.kMeans[i]);
            }

        }
    };

    static public Initialization getKMeansInitialization(final Object[] initKmeans) {
        return new Initialization() {
            public void invoke(KMeansState state) {
                Function copyFunction=((FuzzyKMeansState)state).fkmc.getCopyFunction();
                for (int i = 0; i < state.clusterCount; i++) {
                    state.kMeans[i] = copyFunction.invoke(
                            initKmeans[i], state.kMeans[i]);
                }

            }
        };
    }

    /**
     * @param fuzzifier
     */
    public static FuzzyKMeansClustering getComplexFuzzyKMeans(double fuzzifier,
            int length) {
        return new FuzzyKMeans(KMeansUtils.getComplexDistance(length),
                fuzzifier, FuzzyKMeans.OBJECTIVE, FuzzyKMeans.SEPARATION,
                INITALIZE, KMeansUtils
                        .getComplexCopyFunction(length), FuzzyAverages
                        .getComplexMeansFunction(length));
    }

    public static FuzzyKMeansClustering getComplexFuzzyKMeans(double fuzzifier,
            double noiseDistance, int length) {
        return new FuzzyKMeans(KMeansUtils.getComplexDistance(length),
                fuzzifier, FuzzyKMeans.OBJECTIVE, FuzzyKMeans.SEPARATION,
                INITALIZE, KMeansUtils
                        .getComplexCopyFunction(length), FuzzyAverages
                        .getComplexMeansFunction(length), noiseDistance);
    }

    /**
     * @param fuzzifier
     */
    public static FuzzyKMeans getDoubleFuzzyKMeans(double fuzzifier, int length) {
        return new FuzzyKMeans(KMeansUtils.getDoubleDistance(length),
                fuzzifier, FuzzyKMeans.OBJECTIVE, FuzzyKMeans.SEPARATION,
                INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(length), FuzzyAverages
                        .getDoubleMeansFunction(length));
    }

    public static FuzzyKMeans getDoubleFuzzyKMeans(double fuzzifier,
            double noiseDistance, int length) {
        return new FuzzyKMeans(KMeansUtils.getDoubleDistance(length),
                fuzzifier, FuzzyKMeans.OBJECTIVE, FuzzyKMeans.SEPARATION,
                INITALIZE, KMeansUtils
                        .getDoubleCopyFunction(length), FuzzyAverages
                        .getDoubleMeansFunction(length), noiseDistance);
    }

}
