/*
 * Created on 23.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package weka.classifiers.lazy;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import weka.classifiers.Classifier;
import weka.core.Instance;
import weka.core.Instances;
import weka.core.NormDistance;


/**
 * @author beringer
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class FuzzyIB extends Classifier {
	
	int[] xPos=null;
	int yPos=-1;
	
	double[] c;
	double stdC1=0.25;
	double stdC2=0.25;
	double tolerance=0.9;
	Instances data;
	NormDistance dist;
	IB1 ib1;

	public void buildClassifier(Instances data) throws Exception {
		this.data=data;
		//ib1=new IB1();
		//ib1.buildClassifier(data);
		init();
		c=new double[data.numInstances()];
		for(int i=0;i<data.numInstances();i++){
			Instance inst=data.instance(i);
			c[i]=0.5;
			for (int j=0;j<data.numInstances();j++){
				if (i==j) continue;
				Instance inst2=data.instance(j);
				double dist1=dist1(inst,inst2);
				double dist2=dist2(inst,inst2);
				double sim1=0;
				if (c[i]>0) sim1=Math.max(0,1.0-(dist1/c[i]));
				else if (dist1==0.0) sim1=1;
				double sim2=Math.max(0,1.0-(dist2/stdC1));
				double dissim1=1-sim1;//Math.max(0,(c[i]-(1-dist1))/c[i]);
				//double dissim2=1-sim2;
				//double dissim2=Math.max(0,1.0-((1-dist2)/(1-stdC)));
				
				double dissim2=Math.min(1.0,Math.max(0,(dist2-stdC2)/(0.5-stdC2)));
				if (sim1<0 || sim1>1) 
					System.out.println("ERROR1");
				if (sim2<0 || sim2>1) 
					System.out.println("ERROR2 "+sim2);
				double p=Math.max(dissim1,1-dissim2);
				if (p<tolerance){
					c[i]=dist1/(tolerance);
					sim1=0;
					if (c[i]>0) sim1=Math.max(0,1.0-(dist1/c[i]));
					else if (dist1==0.0) sim1=1;
					if ((sim1+tolerance<0.9999)||(sim1+tolerance>1.0001)){
						System.out.println("ERROR3");
					}
				}
			}
		}
	}
	
	public void init(){
		int atts=data.numAttributes();
		
		yPos=data.classIndex();
		if (xPos==null){
			xPos=new int[atts-1];
			int offset=0;
			for (int i=0;i<atts-1;i++){
				while(offset+i==yPos) offset++;
				xPos[i]=i+offset;
			}
		}
		
		boolean[] use=new boolean[atts];
		for (int i=0;i<xPos.length;i++){
			use[xPos[i]]=true;
		}
		use[yPos]=true;
		dist=new NormDistance(data,use,true,false);
	}
	
	public double[] getFuzzyValue(Instance newInst){
		double delta=0.0;
		double pi=1.0;
		double pi2=0.0;
		for (int i=0;i<data.numInstances();i++){
			Instance inst=data.instance(i);
			double dist1=dist1(newInst,inst);
			double dist2=dist2(newInst,inst);
			double sim1=0;
			if (c[i]>0) sim1=Math.max(0,1.0-(dist1/c[i]));
			else if (dist1==0.0) sim1=1;
			double sim2=Math.max(0,1.0-(dist2/stdC1));
			double dissim1=1-sim1;//Math.max(0,(c[i]-(1-dist1))/c[i]);
			//double dissim2=1-sim2;
			//double dissim2=Math.max(0,1.0-((1-dist2)/(1-stdC)));
			double dissim2=Math.min(1.0,Math.max(0,(dist2-stdC2)/(0.5-stdC2)));
			double d=Math.min(sim1,sim2);
			if (d>delta) delta=d;
			double p=Math.max(dissim1,1-dissim2);
			if (p<pi) pi=p;
			p=Math.min(sim1,dissim2);
			if (p>pi2) pi2=p;
			System.out.print("");
		}
		if (Math.abs(pi-(1.0-pi2))>0.00001) System.out.println("WRONG "+newInst+" "+pi+", "+(1.0-pi2));
		return new double[]{delta,pi};
	}
	
	
	
	public double dist1(Instance inst,Instance inst2){
		double distance=0;
		for (int i=0;i<xPos.length;i++){
			double val=dist.distance(xPos[i],inst.value(xPos[i]),inst2.value(xPos[i]));
			//distance=Math.max(Math.abs(val),distance); //MAX-Distance
			//distance+=val*val;//L2-Distance
			distance+=Math.abs(val);//L1-Distance
		}
		//NORM:
		//MAX-Distance is normed
		//distance=Math.sqrt(distance)/Math.sqrt(xPos.length);//L2-Distance
		distance=distance/xPos.length;//L1-Distance
		
		return distance;
	}
	
		
	public double dist2(Instance inst,Instance inst2){
		return Math.abs(dist.distance(yPos,inst.value(yPos),inst2.value(yPos)));
		//return Math.abs(inst.value(yPos)-inst2.value(yPos));
	}
	
	public double classifyInstance(Instance inst){
		double min=dist.getMinimum(yPos);
		double max=dist.getMaximum(yPos);
		double mmdist=max-min;
		double result=classify(inst,min,max,15);
		min=Math.max(min,result-0.1*mmdist);
		max=Math.min(max,result+0.1*mmdist);
		mmdist=max-min;
		result=classify(inst,min,max,15);
		/*min=Math.max(min,result-0.1*mmdist);
		max=Math.min(max,result+0.1*mmdist);
		mmdist=max-min;
		result=classify(inst,min,max,15);*/
		/*try{
			double val=ib1.classifyInstance(inst);
			Instance instance=new Instance(inst);
			instance.setValue(yPos,result);
			double[] fuz1=getFuzzyValue(instance);
			instance.setValue(yPos,val);
			double[] fuz2=getFuzzyValue(instance);
			if (fuz1[0]<fuz2[0]) System.out.println("shit");
		}catch (Exception e){
			e.printStackTrace();
		}*/
		return result;
	}
	
	protected double classify(Instance inst, double min, double max,int zones){
		Instance instance=(Instance)inst.copy();
		double[][] fuzzyval=new double[zones+1][];
		double maxDelta=0.0;
		List best=new ArrayList();
		double mmdist=max-min;
		for (int i=0;i<zones;i++){
			instance.setValue(yPos,((double)mmdist*i/zones)+min);
			fuzzyval[i]=getFuzzyValue(instance);
			if (fuzzyval[i][0]>maxDelta){
				best.clear();
				maxDelta=fuzzyval[i][0];
				best.add(new Integer(i));
			}
			else if (fuzzyval[i][0]==maxDelta){
				best.add(new Integer(i));
			}
		}
		int size1=best.size();
		
		if (best.size()>1){
			double maxPi=0.0;
			List bestPi=new ArrayList();
			Iterator it=best.iterator();
			while(it.hasNext()){
				int i=((Integer)it.next()).intValue();
				if (fuzzyval[i][1]>maxPi){
					bestPi.clear();
					maxPi=fuzzyval[i][1];
					bestPi.add(new Integer(i));
				}
				else if (fuzzyval[i][1]==maxPi){
					bestPi.add(new Integer(i));
				}
			}
			//if (bestPi.size()<best.size()) System.out.println("improved: "+bestPi.size()+" von "+best.size());
			//else System.out.println("not improved: "+bestPi.size());
			best=bestPi;
		}
		double result=0;
		if (best.size()>0){
			double sum=0;
			Iterator it=best.iterator();
			while(it.hasNext()){
				int i=((Integer)it.next()).intValue();
				sum+=i;
			}
			sum=sum/best.size();
			result=(sum*mmdist/zones)+min;
		}
		else {
			int p1=((Integer)best.get(0)).intValue();
			result=(p1*mmdist/zones)+min;
		}
		return result;
		
	}

	public static void main(String[] args) {
	}
}
