/*
 * Created on 23.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package weka.classifiers.lazy;

import weka.core.Instance;
import weka.core.Instances;
import weka.core.NormDistance;


/**
 * @author beringer
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class FuzzyIB2 extends FuzzyIB {
	
	int xPos=0;
	int yPos=1;
	
	double[] c;
	double stdC=0.5;
	double tolerance=1.0;
	Instances data;
	NormDistance dist;

	public void buildClassifier(Instances data) throws Exception {
		this.data=data;
		dist=new NormDistance(data,new boolean[]{true,true},true,false);
		c=new double[data.numInstances()];
		for(int i=0;i<data.numInstances();i++){
			Instance newInst=data.instance(i);
			c[i]=0.5;
			for (int j=0;j<data.numInstances();j++){
				if (i==j) continue;
				Instance inst=data.instance(j);
				double dist1=dist1(newInst,inst);
				double dist2=dist2(newInst,inst);
				double sim1=Math.max(0,1.0-(dist1/stdC));
				double sim2=Math.max(0,1.0-(dist2/c[i]));
				double dissim1=1-sim1;//Math.max(0,(c[i]-(1-dist1))/c[i]);
				//double dissim2=1-sim2;
				double dissim2=Math.max(0,1.0-((1-dist2)/c[i]));
				if (sim1<0 || sim1>1) 
					System.out.println("ERROR1");
				if (sim2<0 || sim2>1) 
					System.out.println("ERROR2");
				double p=Math.max(dissim1,1-dissim2);
				if (p<tolerance){
					c[i]=(1-dist2)/(tolerance);
					dissim2=Math.max(0,1.0-((1-dist2)/c[i]));
					if ((1-dissim2<tolerance-0.0001)||(1-dissim2>tolerance+0.0001)){
						System.out.println("ERROR3");
					}
				}
				
			}
		}
	}
	
	public double[] getFuzzyValue(Instance newInst){
		double delta=0.0;
		double pi=1.0;
		for (int i=0;i<data.numInstances();i++){
			Instance inst=data.instance(i);
			double dist1=dist1(newInst,inst);
			double dist2=dist2(newInst,inst);
			double sim1=Math.max(0,1.0-(dist1/stdC));
			double sim2=Math.max(0,1.0-(dist2/c[i]));
			double dissim1=1-sim1;//Math.max(0,(c[i]-(1-dist1))/c[i]);
			//double dissim2=1-sim2;
			double dissim2=Math.max(0,1.0-((1-dist2)/c[i]));
			double d=Math.min(sim1,sim2);
			if (d>delta) delta=d;
			double p=Math.max(dissim1,1-dissim2);
			if (p<pi) pi=p;
			System.out.print("");
		}
		return new double[]{delta,pi};
	}
	
	public double dist1(Instance inst,Instance inst2){
		//return Math.abs(dist.distance(yPos,inst.value(yPos),inst2.value(yPos)));
		return Math.abs(inst.value(xPos)-inst2.value(xPos));
	}
	
		
	public double dist2(Instance inst,Instance inst2){
		//return Math.abs(dist.distance(yPos,inst.value(yPos),inst2.value(yPos)));
		return Math.abs(inst.value(yPos)-inst2.value(yPos));
	}

	public static void main(String[] args) {
	}
}
