


package weka.core.fuzzy;

import weka.core.Attribute;
import weka.core.Instance;


/**
 * @author beringer
 *
 */
public class FuzzySet {
	
	FuzzySetFunction function;
	
	Attribute attribute;
	
	String name;
	
	
	public FuzzySet(Attribute attribute, FuzzySetFunction function, String name){
		this.attribute=attribute;
		this.function=function;
		this.name=name;
	}
	
	public Attribute getAttribute(){
		return attribute;
	}
	
	public FuzzySetFunction getFuzzySetFunction(){
		return function;
	}
	
	public double getFuzzyValue(Instance inst){
		return function.getFuzzyValue(inst.value(attribute));
	}
	
	public double getFuzzyValue(double value){
		return function.getFuzzyValue(value);
	}
	
	public String toString(){
		return function.toString();
	}

}
