package weka.core.fuzzy.norm;
import java.io.Serializable;

/**
* An implementation of interface Implication (Goedel Implication)
* @author Yasuyuki Yokoyama
*/
public class GoedelImplication implements Implication, Serializable{ // R-Implication
	
	/** Constructs a GoedelImplication object. */
	public GoedelImplication(){}
	
	/** Returns the result of the application of GoedelImplication.
	* @param value1 Float-value of the first argument.
	* @param value2 Float-value of the second argument.
	* @return Float-value of GoedelImplication with value1 and value2.
	*/
	public double invoke(double value1, double value2){
		return (value1<=value2)?1:value2;  
	}
	
	public double invoke(double[] values) {
		throw new UnsupportedOperationException();
	}
}