package weka.core.fuzzy.norm;
import java.io.Serializable;

/**
* An implementation of interface Implication (Goguen Implication)
* @author Yasuyuki Yokoyama
*/
public class GoguenImplication implements Implication, Serializable{ // R-Implication
	
	/** Constructs a GoguenImplication object. */
	public GoguenImplication(){}
	
	/**
	* Returns the result of an application of GoguenImplication to 2 arguments.
	* @param value1 Float-value of the first argument.
	* @param value2 Float-value of the second argument.
	* @return Float-value of GoguenImplication with value1 and value2. 
	*/
	public double invoke(double value1, double value2){
		return (value1<value2)?1:(value2/value1); 
	}
	
	public double invoke(double[] values) {
		throw new UnsupportedOperationException();
	}
}