package weka.core.fuzzy.norm;
import java.io.Serializable;

/**
* An implementation of interface Implication (Kleene-Dienes-Implication)
* @author Yasuyuki Yokoyama
*/
public class KDImplication implements Implication, Serializable{ // S-Implication
	
	/** Constructs a KDImplication object. */
	public KDImplication(){} 
	
	/**
	* Returns the result of an application of KDImplication.
	* @param value1 Float-value of the first argument.
	* @param value2 Float-value of the second argument.
	* @return Float-value of KDImplication with value1 and value2 (i.e. Max(value1, value2)).
	*/
	public double invoke(double value1, double value2){
		double value = 1- value1;
		return Math.max(value,value2);
	}
	
	public double invoke(double[] values) {
		throw new UnsupportedOperationException();
	}
}