package weka.core.fuzzy.norm;
import java.io.Serializable;

/**
* An implementation of interface Implication (Lukasiewicz Implication)
* @author Yasuyuki Yokoyama
*/
public class LukasiewiczImplication implements Implication, Serializable{ // R- and S-Implication
	
	/** Constructs a LukasiewiczImplication object. */
	public LukasiewiczImplication(){}
	
	/** 
	* Returns the result of an application of LukasiewiczImplication.
	* @param value1 Float-value of the first argument.
	* @param value2 Float-value of the second argument.
	* @return Float-value of the LukasiewiczImplication with value1 and value2.
	*/
	public double invoke(double value1, double value2){
		double value = 1- value1 + value2;
		return Math.min(1,value);
	}
	
	public double invoke(double[] values) {
		throw new UnsupportedOperationException();
	}
}