package weka.core.fuzzy.norm;
import java.io.Serializable;

/**
* An implementation of interface Implication (Reichenbach Implication)
* @author Yasuyuki Yokoyama
*/
public class ReichenbachImplication implements Implication, Serializable{ // S-Implication
	
	/** Constructs a ReichenbachImplication object. */
	public ReichenbachImplication(){}
	
	/**
	* Returns the result of an application of ReichenbachImplication.
	* @param value1 Float-value of the first argument.
	* @param value2 Float-value of the second argument.
	* @return Float-value of ReichenbachImplication with value1 and value2 (i.e. 1-value1+value1*value2). 
	*/
	public double invoke(double value1, double value2){
		return 1 - value1 + value1*value2;
	}
	
	public double invoke(double[] values) {
		throw new UnsupportedOperationException();
	}
}